// Arcadeflow - v 4.2
// Attract Mode Theme by zpaolo11x
//
// Based on carrier.nut scrolling module by Radek Dutkiewicz (oomek)
// Including code from the KeyboardSearch plugin by Andrew Mickelson (mickelson)

fe.load_module("file")
fe.do_nut("pic_functions.nut")

local frm = {
   orderx = 0
   preliner = "  ○ "
   prelinerh = "● "
   postliner = "                                                                                                  "
}

class UserConfig </ help="" />{
   </ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx0 = " "

	</ label=frm.prelinerh + "GENERAL" + frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramx1 = " "
		</ label=frm.preliner + "Context menu button" + frm.postliner, help="Chose the button to open the game context menu", options="select, custom1, custom2, custom3, custom4, custom5, custom6", order=frm.orderx++ /> overmenubutton="select"
		</ label=frm.preliner + "Rows in horizontal" + frm.postliner, help = "Number of rows to use in 'horizontal' mode", options="1, 2, 3", order = frm.orderx++ /> horizontalrows = "2"
		</ label=frm.preliner + "Rows in vertical" + frm.postliner, help = "Number of rows to use in 'vertical' mode", options="1, 2, 3", order = frm.orderx++ /> verticalrows = "3"
		</ label=frm.preliner + "Scrollbar style" + frm.postliner, help = "Select how the scrollbar should look", options="Timeline, Scrollbar, LabelList", order = frm.orderx++ /> scrollertype = "Timeline"
		</ label=frm.preliner + "Smooth shadow" + frm.postliner, help = "Enable smooth shadow under game title and data in the GUI", options="Yes, No", order = frm.orderx++ /> datashadowsmooth = "Yes"
		</ label=frm.preliner + "Screen rotation" + frm.postliner, help = "Rotate screen", options="None, Left, Right, Flip", order = frm.orderx++ /> baserotation = "None"
		</ label=frm.preliner + "Frosted glass" + frm.postliner, help = "Enable a frosted glass effect for overlay menus", options="Yes, No", order = frm.orderx++ /> frostedglass = "Yes"
      </ label=frm.preliner + "Low resolution" + frm.postliner, help = "Optimize theme for low resolution screens, 1 row layout forced, increased font size and cleaner layout", options="Yes, No", order = frm.orderx++ /> lowres = "No"
		</ label=frm.preliner + "Resolution W x H" + frm.postliner, help = "Define a custom resolution for your layout independent of screen resolution. Format is WIDTHxHEIGHT, leave blank for default resolution", order = frm.orderx++ /> customsize = ""
	</ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx1 = " "

	</ label=frm.prelinerh + "THUMBNAILS" + frm.postliner, help=" ", options =" ", order=frm.orderx++ /> paramx2 = " "
		</ label=frm.preliner+"Aspect ratio" + frm.postliner, help="Chose wether you want cropped, square snaps or horizontal and vertical snaps depending on game orientation", options ="Horizontal-Vertical, Square", order = frm.orderx++ /> cropsnaps = "Horizontal-Vertical"
		</ label=frm.preliner+"Glow effect" + frm.postliner, help="Add a glowing halo around the selected game thumbnail", options="Yes, No", order=frm.orderx++ /> snapglow ="Yes"
		</ label=frm.preliner+"Video thumbs" + frm.postliner, help="Enable video overlay on snapshot thumbnails", options="Yes, No", order=frm.orderx++ /> thumbvideo ="Yes"
		</ label=frm.preliner+"Thumb gradient" + frm.postliner, help="Blurs the artwork behind the game logo so it's more readable", options="Yes, No", order=frm.orderx++ /> snapgradient="Yes"
		</ label=frm.preliner+"New game indicator" + frm.postliner, help="Games not played are marked with a glyph", options="Yes, No", order=frm.orderx++ /> newgame = "Yes"
	</ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx2 = " "

	</ label=frm.prelinerh + "BACKGROUND" + frm.postliner, help=" ", options =" ", order=frm.orderx++ /> paramx3 = " "
		</ label=frm.preliner+"Overlay color" + frm.postliner, help="Setup theme luminosity overlay, Basic is slightly muted, Dark is darker, Light has a white overlay and dark text, Pop keeps the colors unaltered", options="Basic, Dark, Light, Pop", order=frm.orderx++ /> colortheme="Pop"
		</ label=frm.preliner+"Custom BG image" + frm.postliner, help="Insert custom background art path (use grey.png for blank background, vignette.png for vignette overlay)", order=frm.orderx++ /> bgblurred=""
		</ label=frm.preliner+"Background snap" + frm.postliner, help="Add a faded game snapshot to the background", options="Yes, No", order=frm.orderx++ /> layersnap ="No"
		</ label=frm.preliner+"Animate BG snap" + frm.postliner, help="Animate video on background", options="Yes, No", order=frm.orderx++ /> layervideo ="No"
	</ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx3 = " "

	</ label=frm.prelinerh + "LOGO" + frm.postliner, help=" ", options =" ", order=frm.orderx++ /> paramx4 = " "
		</ label=frm.preliner+"Enable splash logo" + frm.postliner, help="Enable or disable the AF start logo", options="Yes, No",order = frm.orderx++/> splashlogo = "Yes"
		</ label=frm.preliner+"Custom splash logo" + frm.postliner, help="Insert the path to a custom AF splash logo (or keep blank for default logo)", order = frm.orderx++/> splashlogofile = ""
	</ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx4 = " "

	</ label=frm.prelinerh + "ATTRACT MODE" + frm.postliner, help=" ", options =" ", order=frm.orderx++ /> paramx5 = " "
		</ label=frm.preliner+"Enable attract mode" + frm.postliner, help="Enable or disable attract mode at layout startup", options="From start, Inactivity only, Disabled",order = frm.orderx++/> amenable = "Inactivity only"
		</ label=frm.preliner+"Background music" + frm.postliner, help="Path to a music file to play in background", order = frm.orderx++/> amtune = ""		
		</ label=frm.preliner+"Enable game sound" + frm.postliner, help="Enable game sounds during attract mode", options="Yes, No",order = frm.orderx++/> amsound = "Yes"		
      </ label=frm.preliner+"Attract mode timer [s]" + frm.postliner, help="Inactivity timer before attract mode is enabled", order = frm.orderx++/> amtimer = 120
		</ label=frm.preliner+"Game change time [s]" + frm.postliner, help="Time interval between each game change", order = frm.orderx++/> amchangetimer = 10
		</ label=frm.preliner+"Attract message" + frm.postliner, help="Text to show during attract mode", order = frm.orderx++/> ammessage = " - PRESS ANY KEY - "
	</ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx5 = " "

	</ label=frm.prelinerh + "SEARCH" + frm.postliner, help=" ", options =" ", order=frm.orderx++ /> paramx6 = " "
		</ label=frm.preliner+"Search entry method" + frm.postliner, help="Use keyboard or on-screen keys to enter search string", options="Keyboard, Screen keys", order=frm.orderx++ /> searchmeth = "Screen keys"
		</ label=frm.preliner+"Immediate search" + frm.postliner, help="Live update results while searching", options="Yes, No", order=frm.orderx++ /> livesearch = "Yes"
	</ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx6 = " "

	</ label=frm.prelinerh + "HISTORY" + frm.postliner, help=" ", options =" ", order=frm.orderx++ /> paramx7 = " "
		</ label=frm.preliner+"Scanline effect" + frm.postliner, help="Select scanline effect: Scanlines = default scanlines, Aperture = aperture mask, Half Resolution = reduced scanline resolution to avoid moiree, None = no scanline", options = "Scanlines, Half Resolution, Aperture, None", order=frm.orderx++ /> scanlinemode="Aperture"
		</ label=frm.preliner+"Text panel style" + frm.postliner, help="Select the look of the history text panel", options = "White panel, Background", order=frm.orderx++ /> historypanel="White panel"
		</ label=frm.preliner+"Game panel style" + frm.postliner, help="Select the look of the history game panel", options = "Dark, Standard", order=frm.orderx++ /> darkpanel="Standard"
      </ label=frm.preliner+"History.dat" + frm.postliner, help="History.dat location.", order=frm.orderx++ /> dat_path="$HOME/mame/dats/history.dat"
		</ label=frm.preliner+"Index clones" + frm.postliner, help="Set whether entries for clones should be included in the index. Enabling this will make the index significantly larger", order=frm.orderx++, options="Yes, No" /> index_clones="Yes"
		</ label=frm.preliner+"Generate index" + frm.postliner, help="Generate the history.dat index now (this can take some time)", is_function=true, order=frm.orderx++ />generate="generate_index"
	</ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx7 = " "

	</ label=frm.prelinerh + "AUDIO" + frm.postliner, help=" ", options =" ", order=frm.orderx++ /> paramx8 = " "
		</ label = frm.preliner + "Theme sound" + frm.postliner, help = "Enable audio sounds when browsing and moving around the theme", options = "Yes, No", order = frm.orderx++ /> themeaudio = "Yes"
      </ label=frm.preliner+"Audio in videos (thumbs)" + frm.postliner, help="Select wether you want to play audio in videos on thumbs", options="Yes, No", order=frm.orderx++ /> audiovidsnaps="No"
		</ label=frm.preliner+"Audio in videos (history)" + frm.postliner, help="Select wether you want to play audio in videos on history detail page", options="Yes, No", order=frm.orderx++ /> audiovidhistory="No"
	</ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx8 = " "

	</ label=frm.prelinerh + "DEBUG" + frm.postliner, help=" ", options =" ", order=frm.orderx++ /> paramx9 = " "
		</ label = frm.preliner + "FPS counter" + frm.postliner, help = "DEBUG FPS COUNTER", options = "Yes, No", order = frm.orderx++ /> fpson = "No"
	</ label= frm.postliner, help=" ", options = " ", order=frm.orderx++ /> paramxx9 = " "

}

/// Layout start  

// for debug purposes
local DEBUG = false
local DEBUGPRINTER = false

local transdata = ["StartLayout", "EndLayout", "ToNewSelection","FromOldSelection","ToGame","FromGame","ToNewList","EndNavigation","ShowOverlay","HideOverlay","NewSelOverlay","ChangedTag"]

local bgvidsurf = null

local bg_stacksize = 5
local bgs = {
   bgpicarray = []
   bgvidarray = []
   alphapos = []
}

local data_stacksize = 5
local dat = {
   var_array = []
   cat_array = []
   but_array = []
   ctl_array = []
   ply_array = []
   mainctg_array = []
   manufacturer_array = []
   gamename_array = []
   gamesubname_array = []
   gameyear_array = []
   alphapos = []
}

dofile( fe.script_dir + "file_util.nut" )

local my_config = fe.get_config()

local prf = {
   OVERMENUBUTTON = my_config["overmenubutton"],
   HORIZONTALROWS = ( (my_config["horizontalrows"] ).tointeger()),
   VERTICALROWS = ( (my_config["verticalrows"] ).tointeger()),
   DATASHADOWSMOOTH = ( (my_config["datashadowsmooth"] == "Yes") ? true : false),
   BASEROTATION = my_config["baserotation"],
   FROSTEDGLASS = ( (my_config["frostedglass"] == "Yes") ? true : false),
   LOWRES = ( (my_config["lowres"] == "Yes") ? true : false),
   CUSTOMSIZE = my_config["customsize"],
   SCROLLERTYPE = my_config["scrollertype"],

   CROPSNAPS = ( (my_config["cropsnaps"] == "Square") ? true : false),
   SNAPGLOW = ( (my_config["snapglow"] == "Yes") ? true : false),
   THUMBVIDEO = ( (my_config["thumbvideo"] == "Yes") ? true : false),
   SNAPGRADIENT = ( (my_config["snapgradient"] == "Yes") ? true : false),
   NEWGAME = ( (my_config["newgame"] == "Yes") ? true : false),

   COLORTHEME = my_config["colortheme"],
   BGBLURRED = my_config["bgblurred"],
   LAYERSNAP = ( (my_config["layersnap"] == "Yes") ? true : false),
   LAYERVIDEO = ( (my_config["layervideo"] == "Yes") ? true : false),

   SPLASHON = ( (my_config["splashlogo"] == "Yes") ? true : false ),
   SPLASHLOGOFILE = ( my_config["splashlogofile"] == "" ? "aflogow3.png" : my_config["splashlogofile"]),

   AMENABLE = ( (my_config["amenable"] != "Disabled") ? true : false ),
   AMSTART = ( (my_config["amenable"] == "From start") ? true : false ),
   AMTUNE = my_config["amtune"],
   AMSOUND = ( (my_config["amsound"] == "Yes") ? true : false ),
   AMTIMER = ( (my_config["amtimer"] )),
   AMCHANGETIMER = ( (my_config["amchangetimer"] )),
   AMMESSAGE =my_config["ammessage"],

   KEYBOARD = ( (my_config["searchmeth"] == "Keyboard") ? true : false),
   LIVESEARCH = ( (my_config["livesearch"] == "Yes") ? true : false ),

   SCANLINEMODE = my_config["scanlinemode"],
   HISTORYPANEL = (( my_config["historypanel"] == "White panel" ) ? true : false),
   DARKPANEL = (( my_config["darkpanel"] == "Dark" ) ? true : false),

   THEMEAUDIO = ( (my_config["themeaudio"] == "Yes") ? true : false),
   AUDIOVIDSNAPS = ( (my_config["audiovidsnaps"] == "Yes") ? true : false),
   AUDIOVIDHISTORY = ( (my_config["audiovidhistory"] == "Yes") ? true : false),

   FPSON = ( (my_config["fpson"] == "Yes") ? true : false),
}

try {prf.AMTIMER = prf.AMTIMER.tointeger()}
catch (err) {prf.AMTIMER = 120}

try {prf.AMCHANGETIMER = prf.AMCHANGETIMER.tointeger()}
catch (err) {prf.AMCHANGETIMER = 10}

if (prf.BASEROTATION == "None") {
	fe.layout.base_rotation = RotateScreen.None
}
else if (prf.BASEROTATION == "Left") {
	fe.layout.base_rotation = RotateScreen.Left
}
else if (prf.BASEROTATION == "Right") {
	fe.layout.base_rotation = RotateScreen.Right
}
else if (prf.BASEROTATION == "Flip") {
	fe.layout.base_rotation = RotateScreen.Flip
}



// cleanup frosted glass screen grabs
local dir0 = DirectoryListing( FeConfigDirectory )
local fpos01 = null
local fpos02 = null

// workaround when no screenshots are present in the folder
if (file_exist(FeConfigDirectory+"screen.png") == false){
	fe.signal ("screenshot")
}

foreach ( f in dir0.results ){
	fpos01 = f.find(".png")
	fpos02 = f.find("frostgrab")
	if ((fpos01 != null) && (fpos02 != null)){
		remove(f)
	}
}

// Initialize variables
local var = 0

// Fade data: [0 - FADE COUNTER, 1 - FADE VALUE, 2 - FADE STARTER, 3 - FADE INCREASER, 4 - FADE EASER]
// FADE COUNTER counts from 0 to 1 (if FADE INCREASER > 0) or from 1 to 0 (FADE INCREASER < 0) linearly
// FADE VALUE is a fade value calculated from FADE COUNTER based on FADE EASER: 0.0 linear, 1.0 ease start, -1.0 ease stop
// FADE STARTER is the counter value at which the fade is when changing fade, 
// it should be equal to FADE VALUE and FADE COUNTER when initializing the variable, 
// is used for incremental non-linear fading and shouldn't be touched if not by startfade function

local flowT = {
   overmenu = [0.0,0.0,0.0,0.0,0.0]
   history = [0.0,0.0,0.0,0.0,0.0]
   histtext = [0.0,0.0,0.0,0.0,0.0]
   data = [0.0,0.0,0.0,0.0,0.0]
   logo = [1.0,1.0,1.0,0.0,0.0]
   fg = [1.0,1.0,1.0,0.0,0.0]
   attract = [1.0,1.0,1.0,0.0,0.0]
   gametoblack = [0.0,0.0,0.0,0.0,0.0]
   blacker = [1.0,1.0,1.0,0.0,0.0]
   historydata = [0.0,0.0,0.0,0.0,0.0]
   historyscroll = [0.0,0.0,0.0,0.0,0.0]
   historyblack = [0.0,0.0,0.0,0.0,0.0]
   frostfade = [1.0,1.0,1.0,0.0,0.0,0.0]
}

local scrollreset = false

local noshader = fe.add_shader( Shader.Empty )

// Search parameters
local search_base_rule = "Title"
local backindex = -1
local backcorrector = -1

local tagsmenu = false

local	colstop = 0
local	colstart = 0
local columnoffset = 0

local squarizer = true

// Apply color theme
local themeT = {
   themeoverlaycolor = 255
   themeoverlayalpha = 80
   themetextcolor = 255
   themehistorytextcolor = 90
   themeshadow = 50
}

local satinrate = 0.9
local vidsatin = 50

if (prf.COLORTHEME == "Basic"){
	themeT.themeoverlaycolor = 255
	themeT.themeoverlayalpha = 80
	themeT.themetextcolor = 255
	themeT.themehistorytextcolor = 90
	themeT.themeshadow = 50
}
if (prf.COLORTHEME == "Dark"){
	themeT.themeoverlaycolor = 0
	themeT.themeoverlayalpha = 110*0 + 140
	themeT.themetextcolor = 230
	themeT.themehistorytextcolor = 90
	themeT.themeshadow = 80
}
if (prf.COLORTHEME == "Light"){
	themeT.themeoverlaycolor = 255
	themeT.themeoverlayalpha = 190
	themeT.themetextcolor = 90
	themeT.themehistorytextcolor = 90
	themeT.themeshadow = 50
}
if (prf.COLORTHEME == "Pop"){
	themeT.themeoverlaycolor = 255
	themeT.themeoverlayalpha = 0
	themeT.themetextcolor = 255
	themeT.themehistorytextcolor = 90
   themeT.themeshadow = 70
}

// Math functions

function round(x, y) {
	return (x.tofloat()/y+(x>0?0.5:-0.5)).tointeger()*y
}

function max(x,y){
   return (x > y ? x : y)
}

function min(x,y){
   return (x < y ? x : y)
}

// UI sounds
local snd = {
   ticksound = fe.add_sound("mouse3.mp3")
   wooshsound = fe.add_sound("woosh4.mp3")
   attracttune = fe.add_sound(prf.AMTUNE)
}

// parameters for slowing down key repeat on left-right scrolling
local rightcount = 0
local leftcount = 0
local movecount = 3

local globalposnew = 0
local	surfacePos = 0

// layout preferences
local rows = prf.HORIZONTALROWS
local vertical = false

// FADE - Initialize fades
local logoshow = 1

// font definition
local guifont ="Roboto-Allcaps.ttf"
local generalfont = "Roboto-Bold.ttf"
local guifontcondensed = "Roboto-Condensed-Bold.ttf"
local guifontlite = "Roboto-Regular.ttf"

//screen layout definition
local scrw = ScreenWidth
local scrh = ScreenHeight

if (prf.CUSTOMSIZE != ""){
	try {
		scrw = split(prf.CUSTOMSIZE,"xX")[0]
		scrh = split(prf.CUSTOMSIZE,"xX")[1]
		scrw = scrw.tointeger()
		scrh = scrh.tointeger()
		//print ("\n\n\n"+xxx + " x " + yyy + "\n\n\n")
	}
	catch ( err ) { fe.overlay.splash_message("Wrong syntax in screen resolution");prf.CUSTOMSIZE = "";scrw = ScreenWidth; scrh = ScreenHeight }
}

local flw = scrw
local flh = scrh

local realrotation = ( fe.layout.base_rotation + fe.layout.toggle_rotation ) % 4
local rotate90 = ((realrotation % 2) != 0)

if (rotate90){
	flw = scrh
	flh = scrw
}

if (flh>flw) vertical = true

if (vertical) rows = prf.VERTICALROWS

rows = (prf.LOWRES ? 1 : rows)

fe.layout.width = flw
fe.layout.height = flh
fe.layout.preserve_aspect_ratio = true
fe.layout.page_size = rows
fe.layout.font = generalfont

local scalerate = (vertical ? flw : flh)/1200.0

local header_h = (prf.LOWRES ? 260*scalerate : 200*scalerate ) // content
local header_h2 = (prf.LOWRES ? 330*scalerate : (rows == 1 ? 250*scalerate : 200*scalerate))
local footer_h = (prf.LOWRES ? 150*scalerate : 100*scalerate ) // content
local footer_h2 = (prf.LOWRES ? 150*scalerate : (rows == 1 ? 150*scalerate : 100*scalerate)) //spacer


// multiplier of padding space (normally 1/6 of thumb area)
local padding_scaler = (prf.CROPSNAPS ? 100/440.0 : 1/6.0)

local height = (flh - header_h2 - footer_h2)/(rows + rows*padding_scaler + padding_scaler)
local width = height

local padding = height * padding_scaler
local widthpadded = width + 2 * padding
local heightpadded = height + 2 * padding

local verticalshift = (prf.CROPSNAPS ? 0 : height*16.0/480.0)

//calculate number of columns
local cols = (1 + 2*(floor (( flw/2 + width/2 - padding) / (height + padding))))
// add safeguard tiles
cols += 2

// carrier sizing in general layout
local carrierT = {
	x = -(cols*(height + padding) + padding - flw) * 0.5,
	y = header_h2,
	w = cols*(height + padding) + padding,
	h = rows*height + rows*padding + padding
}

// selector and zooming data
local selectorscale = (rows == 1 ? (vertical ? 1.15 : 1.45) : 1.5)

local whitemargin = (prf.CROPSNAPS ? 0.12 : 0.15) 
local selectorwidth = selectorscale * widthpadded

local zoomratio = selectorwidth*1.0/selectorscale
local invzoomratio = 1.0/zoomratio

local selectoroffseth = (selectorwidth - widthpadded)*0.5
local selectoroffsetv = (selectorwidth - widthpadded - verticalshift)*0.5

// correction data for non-centered first tiles
local deltacol = (cols - 3)/2
local centercorrection0 = -deltacol*(width + padding) -(flw - (carrierT.w - 2*(width + padding))) / 2 - padding*(1 + selectorscale*0.5) - width/2 + selectorwidth/2
local centercorrection = 0
local centercorrectionshift = centercorrection0

// transitions speeds
local spdT = {
   scrollspeed = 0.92
   zoomspeed = 0.87
   bgfadespeed = 0.88
   letterspeed = 0.85
   dataspeedin = 0.92
   dataspeedout = 0.88
}

// Video delay parameters to skip fade-in
local delayvid = 0.4
local fadevid = 0.2

// Fading letter and scroller sizes
local lettersize = 250 * scalerate
local footermargin = 200 * scalerate
local scrollersize = 2 * floor (20 * scalerate * 0.5) + 1

// Blurred backdrop definition
local bgT = {
	x = 0
	y = (flh - flw) / 2.0
	w = flw
}

// Picture background definition
local bgpicT = {
	x = 0,
	y = 0,
	w = flw,
	h = flh,
	ar = 1
}

if (vertical){
	bgT.x = (flw - flh) / 2
	bgT.y = 0
	bgT.w = flh
}

// parameters for changing scroll jump spacing
local scrolljump = false
local scrollstep = rows
local sortjump = false

// keys definition for on screen keyboard 
local key_names = { "a": "a", "b": "b", "c": "c", "d": "d", "e": "e", "f": "f", "g": "g", "h": "h", "i": "i", "j": "j", "k": "k", "l": "l", "m": "m", "n": "n", "o": "o", "p": "p", "q": "q", "r": "r", "s": "s", "t": "t", "u": "u", "v": "v", "w": "w", "x": "x", "y": "y", "z": "z", "1": "Num1", "2": "Num2", "3": "Num3", "4": "Num4", "5": "Num5", "6": "Num6", "7": "Num7", "8": "Num8", "9": "Num9", "0": "Num0", "<": "Backspace", " ": "Space", "-": "Clear", "~": "Done","_":"Nope" }
local key_rows = ["abcdefghi123", "jklmnopqr456", "stuvwxyz_789", "- <0","~"]
if (vertical) key_rows = ["1234567890","abcdefghij","klmnopqrst","uvwxyz____","- <","~"]
local key_selected = [0,0]
local s_text = ""

// used in shaders
//local picalpha = fe.add_image("alpha.png",0,0,1,2)

// Frosted glass variables
local frg = {
   grabdither = 0
   grabticker = 0
   oldgrabnum = 0
   grabpath = ""
   firstpath = ""
   grabsignal = ""
   immediatesignal = false
   numgrabs = 0
   createdgrabs = []  
}


/// Misc functions  

// wrap around value witin range 0 - N
function wrap( i, N ) {
   while ( i < 0 ) { i += N }
   while ( i >= N ) { i -= N }
   return i
}

// scale a picture with origin at the center
function picscale (obj,scale){
   obj.width = obj.width * scale
   obj.height = obj.height * scale
   obj.origin_x = obj.width * 0.5
   obj.origin_y = obj.height * 0.5
}

// resize a picture with origin at the center
function picsize (obj,sizex,sizey){
   obj.width = sizex
   obj.height = sizey
   obj.origin_x = obj.width * 0.5
   obj.origin_y = obj.height * 0.5
}

function recalculate( str ) {
	if ( str.len() == 0 ) return ""
	str = str.tolower()
	local words = split( str, " " )
	local temp=""
	foreach ( idx, w in words ) {
		//print("searching: " + w )
		//if ( idx > 0 ) temp += " "
		//foreach( c in w )
		//  if ( c != " " ) temp += ( "1234567890".find(c.tochar()) != null ) ? c.tochar() : "[" + c.tochar().toupper() + c.tochar().tolower() + "]"
		if ( temp.len() > 0 )
		temp += " "
		local f = w.slice( 0, 1 )
		temp += ( "1234567890".find(f) != null ) ? "[" + f + "]" + w.slice(1) : "[" + f.toupper() + f.tolower() + "]" + w.slice(1)
	}
	return temp
}



// gets the first letter of the game name, # if it's a number
function gameletter( offset ) {
   if (fe.filters.len() > 0){

      if (fe.filters[fe.list.filter_index].sort_by == Info.Year){
         local s = fe.game_info( Info.Year, offset )
         return s
      }
      else if (fe.filters[fe.list.filter_index].sort_by == Info.Manufacturer){
         local s = fe.game_info( Info.Manufacturer, offset )
         return s.slice(0,1)		
      }
      else if (fe.filters[fe.list.filter_index].sort_by == Info.Category){
         local s = fe.game_info( Info.Category, offset )
         if (s == "") return "?"
         s = split( s, "/" )
         return strip(s[0])	
         }
      else {
         local s = fe.game_info( Info.Title, offset )
         if (s.find("The ") == 0) s = s.slice(4,s.len())
         local s2 = s.slice(0,1)
         if ("1234567890".find (s2) != null ){
            s2="#"
         }
         return s2
      }
   }
}

// gets the first part of the game name
function gamename1( offset ) {
	local s = split( fe.game_info( Info.Title, offset ), "(" )	
	if ( s.len() > 0 ) {
		return s[0]
	}
	return ""
}

function gamename2( offset ) {
	local s0 = split(fe.game_info( Info.Title, offset ),"(")
	s0 = s0[0]

	local s1 = split( s0, "/" )
	if ( s1.len() > 1 )  {
		return strip(s1[0])+"\n"+strip(s1[1])
	}
	else {
		return s0
	}
}

function gameplaycount( offset ) {
	local s = fe.game_info( Info.PlayedCount, offset )
	if ( s.len() > 0 ) {
		return s[0]
	}
	return ""
}

// gets the second part of the game name, after the "("
function gamesubname( offset ) {
	local s = split( fe.game_info( Info.Title, offset ), "(" )
	local s2 = ""
	if ( s.len() > 1 ) {
		s2 = split(s[1],")")
		return s2[0]
	}
	return ""
}

function maincategory( offset ) {
	local sout = ""
	local s0 = fe.game_info( Info.Category, offset )
	if (s0 == "") return "" 
	local s = split( s0, "/" )
	if ( s.len() > 1 ) {
		sout = strip(s[0]).toupper()
	}
	else sout = strip(s0).toupper()

	switch (sout){
		case "PLATFORM": return "PLATFRM"
		case "MULTIPLAY": return "MULTI"
		case "BALL & PADDLE": return "PADDLE"
		case "FIGHTER":	return "FIGHT"
		case "DRIVING":	return "DRIVE"
		case "MAZE":	return "MAZE"
		case "MISC.": return "MISC"
		case "CASINO": return "CASINO"
		case "SHOOTER": return "SHOOT"
		case "PUZZLE": return "PUZZLE"
		case "SPORTS": return "SPORT"
		case "WHAC-A-MOLE": return "WHAC-M"
		default: return ""
	}
}

function updatescreen(){
   local path = FeConfigDirectory
   local dir = DirectoryListing( path )
   local picname = ""
   local fpos1 = null
   local fpos2 = null
   local picnum = 0
   local picout = 0

   foreach ( f in dir.results ){
      fpos1 = f.find(".png")
      fpos2 = f.find("screen")
      if ((fpos1 != null) && (fpos2 != null)){
         picnum = f.slice(fpos2+6,fpos1)
         // print (picnum+"\n")
         if (picnum == "") picnum = "0"
         picnum = picnum.tointeger()
         if (picout < picnum ) picout = picnum
      }
   }
   picname = FeConfigDirectory + "screen" + picout +".png"
   return picout
}

function getsnap(signalin){
   frostshaders(true)

   frg.oldgrabnum = updatescreen()
   fe.signal("screenshot")
   frg.oldgrabnum ++
   frg.firstpath = FeConfigDirectory + "screen" + frg.oldgrabnum +".png"
   frg.numgrabs ++
   frg.grabpath = FeConfigDirectory + "frostgrab" + frg.numgrabs +".png"
   frg.createdgrabs.push (frg.grabpath)
   frg.grabticker = 1
   frg.grabsignal = signalin

}

/// Background image creation  

local commonground = fe.add_image("grey.png",0,0,flw,flh)
commonground.zorder = -3

local smallsize = 26
local blursize = 1/26.0

local xsurf1 = fe.add_surface(smallsize,smallsize)

local bgpic = null

for (local i = 0; i < bg_stacksize; i++){
	bgs.alphapos.push (0)
	if (i < bg_stacksize -1) 
      bgpic = xsurf1.add_image("black.png",0,0,smallsize,smallsize)
	else
      bgpic = xsurf1.add_artwork("snap",0,0,smallsize,smallsize)
// TEST 
	bgpic.alpha = 255
	bgpic.trigger = Transition.EndNavigation
	bgpic.video_flags = Vid.ImagesOnly
	bgpic.smooth = true
   //bgpic.mipmap = 1
	bgpic.preserve_aspect_ratio = false
	bgs.bgpicarray.push(bgpic)
}

local xsurf2 = fe.add_surface(smallsize,smallsize)

local bg_surface = fe.add_surface(flw,flh)
bg_surface.alpha=255

local shader_bg = {
   h = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
   v = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
}

shader_bg.h.set_texture_param( "texture")
shader_bg.h.set_param("kernelData", 9.0, 2.2)
shader_bg.h.set_param("offsetFactor", blursize, 0.0)
xsurf1.shader = shader_bg.h

shader_bg.v.set_texture_param( "texture")
shader_bg.v.set_param("kernelData", 9.0, 2.2)
shader_bg.v.set_param("offsetFactor", 0.0, blursize)
xsurf2.shader = shader_bg.v

xsurf2.visible = false
xsurf2 = bg_surface.add_clone(xsurf2)
xsurf2.visible = true

xsurf1.visible = false
xsurf1 = xsurf2.add_clone(xsurf1)
xsurf1.visible = true

xsurf2.set_pos(bgT.x,bgT.y,bgT.w,bgT.w)

local pixelgrid = null
local bgvidsize = 90.0

function squaresnaps(){
   for ( local i = 0; i < tilesTotal ; i++ ) {                  
      local indexTemp = wrap( i + tilesTableOffset, tilesTotal )
   }
}

function squarebg(){
	for (local i = 0; i < bg_stacksize ; i++){
		if (bgs.bgpicarray[i].texture_width >= bgs.bgpicarray[i].texture_height){
			bgs.bgpicarray[i].subimg_x = bgs.bgpicarray[i].texture_width * 1/8.0
			bgs.bgpicarray[i].subimg_width = bgs.bgpicarray[i].texture_width * 3/4.0
		}
		else
		{
			bgs.bgpicarray[i].subimg_y = bgs.bgpicarray[i].texture_height * 1/8.0
			bgs.bgpicarray[i].subimg_height = bgs.bgpicarray[i].texture_height * 3/4.0
		}
		if (prf.LAYERSNAP){
			/* 
         bgs.bgvidarray[i].subimg_x = bgs.bgpicarray[i].subimg_x
			bgs.bgvidarray[i].subimg_y = bgs.bgpicarray[i].subimg_y
			bgs.bgvidarray[i].subimg_width = bgs.bgpicarray[i].subimg_width
			bgs.bgvidarray[i].subimg_height = bgs.bgpicarray[i].subimg_height
         */
         if (bgs.bgvidarray[i].texture_width >= bgs.bgvidarray[i].texture_height){
			   bgs.bgvidarray[i].subimg_x = bgs.bgvidarray[i].texture_width * 1/8.0
			   bgs.bgvidarray[i].subimg_width = bgs.bgvidarray[i].texture_width * 3/4.0
		   }
		   else
         {
            bgs.bgvidarray[i].subimg_y = bgs.bgvidarray[i].texture_height * 1/8.0
            bgs.bgvidarray[i].subimg_height = bgs.bgvidarray[i].texture_height * 3/4.0
         }
		}
	}
}

if (prf.LAYERSNAP){
	bgvidsurf = fe.add_surface(bgvidsize,bgvidsize)
	//bgvid1 = bgvidsurf.add_artwork("snap",0,0,bgvidsize,bgvidsize)

	for (local i = 0; i < bg_stacksize; i++){
		local bgvid = null

		if (!prf.LAYERVIDEO) {
			bgvid = bgvidsurf.add_clone(bgs.bgpicarray[i])
			bgvid.video_flags = Vid.ImagesOnly
		}
		else if (i == bg_stacksize - 1 ){
			bgvid = bgvidsurf.add_artwork("snap",0,0,bgvidsize,bgvidsize)
			bgvid.video_flags = Vid.NoAudio
		}
		else{
			bgvid = bgvidsurf.add_clone(bgs.bgpicarray[i])
//			bgvid.video_flags = Vid.NoAudio // TEST 
         bgvid.video_flags = Vid.ImagesOnly
			bgvid.visible = false
		}
		
		bgvid.set_pos(0,0,bgvidsize,bgvidsize)
		bgvid.preserve_aspect_ratio = false
		bgvid.trigger = Transition.EndNavigation
		bgvid.smooth = true
		bgs.bgvidarray.push(bgvid)
	}

	bgvidsurf.smooth = false

	bgvidsurf.alpha = vidsatin

	bgvidsurf.set_pos(bgT.x,bgT.y,bgT.w,bgT.w)

	pixelgrid = fe.add_image("grid128x.png",bgT.x,bgT.y,bgT.w,bgT.w*128.0/bgvidsize)
	pixelgrid.alpha = 50

   bgvidsurf.zorder = pixelgrid.zorder = -2
}

local bgpicture = null

if (prf.BGBLURRED != "")	{
	bgpicture = bg_surface.add_image(prf.BGBLURRED,0,0,flw,flh)
	bgpicture.visible = false
	bgpicT.ar = (bgpicture.texture_width*1.0) / bgpicture.texture_height

	if (bgpicT.ar >= flw/(flh*1.0)){
		bgpicT.h = flh
		bgpicT.w = bgpicT.h * bgpicT.ar
		bgpicT.y = 0
		bgpicT.x = - (bgpicT.w - flw)*0.5
	}
	else {
		bgpicT.w = flw
		bgpicT.h = bgpicT.w / bgpicT.ar*1.0
		bgpicT.y = - (bgpicT.h - flh)*0.5
		bgpicT.x = 0
	}
	bgpicture=bg_surface.add_image (prf.BGBLURRED,bgpicT.x,bgpicT.y,bgpicT.w,bgpicT.h)
	bgpicture.visible=true
}

local bgoverlay = bg_surface.add_text("",0,0,flw,flh)
bgoverlay.set_bg_rgb(themeT.themeoverlaycolor,themeT.themeoverlaycolor,themeT.themeoverlaycolor)
bgoverlay.bg_alpha = themeT.themeoverlayalpha

bg_surface.zorder = -3

/// Carrier - variables definition  

local	tilesTable = []
local	snapzTable = []
local	logozTable = []
local	loshzTable = []
local	favezTable = []
local	donezTable = []
local nw_mxTable = []
local	sh_hzTable = []
local	sh_vzTable = []
local	vidszTable = []
local gradzTable = []
local	vid2zTable = []
local bd_mxTable = []
local glomxTable = []

local	tilesTablePosX = []
local	tilesTablePosY = []
local	tilesTableOffset = 0
local tilesTableZoom = []


local	corrector = 0

local	newfocusindex = 0
local	oldfocusindex = 0
	
local	changedfav = false

local	vidpos = 0
local	fadeletter = 0
local	searchtext = ""

/// Carrier - constructor  
		
local tilesCount = cols * rows
local tilesOffscreen = (vertical ? 3 * rows : 4 * rows)

local tilesTotal = tilesCount + 2*tilesOffscreen
local surfacePosOffset = (tilesOffscreen/rows) * (width+padding)

// fading letter
local letterobj = fe.add_text("[!gameletter]",0,carrierT.y,flw,carrierT.h)
letterobj.alpha = 0
letterobj.charsize = lettersize
letterobj.font = guifont
letterobj.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
letterobj.margin = 0
letterobj.align = Align.MiddleCentre

// scroller definition
local scrolline = fe.add_image ("white.png",footermargin,flh - footer_h*0.5 - 1, flw-2*footermargin,  1 )
//scrolline.alpha = 255
scrolline.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)

local scrollineglow = fe.add_image ("whitedisc2.png",footermargin, flh - footer_h*0.5 - 10*scalerate -1 ,flw-2*footermargin, 20*scalerate + 1)
scrollineglow.visible = false
scrollineglow.alpha = 200
scrollineglow.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)

local scroller = fe.add_image ("whitedisc.png",footermargin - scrollersize*0.5,flh-footer_h*0.5-(scrollersize + 1 )*0.5,scrollersize,scrollersize)
scroller.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)

local scroller2 = fe.add_image ("whitedisc2.png",scroller.x - scrollersize*0.5, scroller.y-scrollersize*0.5,scrollersize*2,scrollersize*2)
scroller2.visible = false
scroller2.alpha = 200
scroller2.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)

if (prf.SCROLLERTYPE == "LabelList") scroller2.alpha = scrollineglow.alpha = scroller.alpha = scrolline.alpha = 0


local searchdata = fe.add_text (fe.list.search_rule,0,flh-footer_h*0.5,flw,footer_h*0.5)
searchdata.align = Align.Centre
searchdata.set_rgb( 255, 255, 255)
searchdata.word_wrap = true
searchdata.charsize = 25*scalerate
searchdata.visible = true
searchdata.font = guifont
searchdata.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)

/// Carrier - tile creation loop  
		
for ( local i = 0; i < tilesTotal; i++ ) {

   local gradsizer = 8
   local gradscaler = 1

   local gradsurf1 = fe.add_surface (gradsizer, gradsizer)

   local gradz = gradsurf1.add_artwork("snap",0,0,gradsizer,gradsizer)
   gradz.preserve_aspect_ratio = false
   gradz.video_flags = Vid.ImagesOnly

   local vidsz = gradsurf1.add_image("transparent.png",0,0,gradsizer,gradsizer)
   vidsz.preserve_aspect_ratio = false
   vidsz.mipmap = 1
   //vidsz.visible = false
   if (!prf.AUDIOVIDSNAPS) vidsz.video_flags = Vid.NoAudio

   local gradsurf2 = fe.add_surface (gradsizer, gradsizer)

   local shader_gr = {
      h = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
      v = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
   }
   
   shader_gr.h.set_texture_param( "texture")
   shader_gr.h.set_param("kernelData", 7.0, 2.5)
   shader_gr.h.set_param("offsetFactor", 1.0/gradsizer, 0.0)
   gradsurf1.shader = shader_gr.h

   shader_gr.v.set_texture_param( "texture")
   shader_gr.v.set_param("kernelData", 7.0, 2.5)
   shader_gr.v.set_param("offsetFactor", 0.0, 1.0/gradsizer)
   gradz.shader = shader_gr.v

   gradsurf1.visible = false
   gradsurf1 = gradsurf2.add_clone (gradsurf1)
   gradsurf1.visible = true
      
   gradsurf2.set_pos (gradsizer*gradscaler*i , 0,gradsizer*gradscaler,gradsizer*gradscaler)
   gradsurf2.visible = false

   local logo_w = 240.0
   local logo_h = (prf.CROPSNAPS ? 105.0 : 120.0)
   local logomargin = 20.0
   local logosh_w = logo_w+2*logomargin
   local logosh_h = logo_h+2*logomargin

   local logoshscale = 0.35

   local logosurf2 = fe.add_surface (logosh_w*logoshscale,logosh_h*logoshscale)

   local loshz = logosurf2.add_artwork ("wheel",logomargin*logoshscale,logomargin*logoshscale,logo_w*logoshscale,logo_h*logoshscale)

   local logosurf1 = fe.add_surface (logosh_w*logoshscale,logosh_h*logoshscale)

   local shader_lg = {
      v = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
      h = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
   }
   
   shader_lg.v.set_texture_param( "texture")
   shader_lg.v.set_param("kernelData", 5.0 , 1.75)
   shader_lg.v.set_param("offsetFactor", 0.0000, 1.0/(logosh_h*logoshscale))
   logosurf2.shader = shader_lg.v

   shader_lg.h.set_texture_param( "texture")
   shader_lg.h.set_param("kernelData", 5.0 , 1.75)
   shader_lg.h.set_param("offsetFactor", 1.0/(logosh_w*logoshscale), 0.0)
   logosurf1.shader = shader_lg.h


   logosurf2.visible = false
   logosurf2 = logosurf1.add_clone (logosurf2)
   logosurf2.visible = true

   logosurf1.visible = false

   // main tile object
   local obj = fe.add_surface(widthpadded*selectorscale,heightpadded*selectorscale)
   obj.origin_x = obj.width * 0.5   
   obj.origin_y = obj.height * 0.5

   obj.zorder = -2
   
   local sh_hz = obj.add_image ("sh_h_7.png",0,0,widthpadded*selectorscale,heightpadded*selectorscale)
   local sh_vz = obj.add_image ("sh_v_7.png",0,0,widthpadded*selectorscale,heightpadded*selectorscale)
   sh_hz.alpha = sh_vz.alpha = 230
   
   if (prf.CROPSNAPS) sh_hz.file_name = sh_vz.file_name = "sh_sq_7.png"

   local glomx = obj.add_image ("glowx5d.png",0,-selectorscale*verticalshift,widthpadded*selectorscale,selectorscale*heightpadded)
   glomx.alpha = 0

   if (prf.CROPSNAPS) glomx.file_name = "glow_sq3.png"

   local bd_mx = obj.add_image ("white.png",selectorscale*padding*(1.0-whitemargin),selectorscale*(-verticalshift + height/8.0 + padding*(1.0 - whitemargin)),selectorscale*(width + padding*2.0*whitemargin),selectorscale*(height*(3/4.0)+padding*2.0*whitemargin))
   bd_mx.set_rgb(255,255,255)
   bd_mx.alpha = 0
   if (prf.CROPSNAPS) {
      bd_mx.set_pos (selectorscale*padding*(1.0-whitemargin),selectorscale*(-verticalshift + padding*(1.0 - whitemargin)),selectorscale*(width + padding*2.0*whitemargin),selectorscale*(height + padding*2.0*whitemargin))
   }   

   local snapz = obj.add_clone(gradz)

   snapz.preserve_aspect_ratio = false
   snapz.video_flags = Vid.ImagesOnly
   snapz.set_pos (selectorscale*padding,selectorscale*(padding-verticalshift),selectorscale*width,selectorscale*height)
 
   local snap_avg = null

   if (prf.SNAPGRADIENT){
      snap_avg = fe.add_shader( Shader.Fragment, "powersampler3.glsl" )
      snap_avg.set_texture_param( "texture",snapz)
      snap_avg.set_texture_param( "texture2",gradsurf2)
      if (prf.CROPSNAPS) 
         snap_avg.set_param ("limits",0.25,0.75)
      else
         snap_avg.set_param ("limits",0.20,0.75)
      snapz.shader = snap_avg
   }
   else snapz.shader = noshader

   local snap_glow = null
   
   if (prf.SNAPGLOW){
      snap_glow = fe.add_shader( Shader.Fragment, "powerglow2_XP.glsl" )
      snap_glow.set_texture_param( "texture",gradsurf2)
      snap_glow.set_texture_param( "textureglow",glomx)
      snap_glow.set_param ("vertical",0.0)
      if (prf.CROPSNAPS) 
         snap_glow.set_param ("cropsnap",1.0)
      else
         snap_glow.set_param ("cropsnap",0.0)

      glomx.shader = snap_glow
   }

   local vid2z = obj.add_clone(vidsz)
   vid2z.set_pos (selectorscale*padding,selectorscale*(padding-verticalshift),selectorscale*width,selectorscale*height)
   vid2z.preserve_aspect_ratio = true
   //vidsz.visible = false

  // if (!prf.AUDIOVIDSNAPS) vid2z.video_flags = Vid.NoAudio

   local nw_mx = obj.add_image ("nw_1.png",selectorscale*padding,selectorscale*(padding-verticalshift+height*6.0/8.0),width*selectorscale/8.0,height*selectorscale/8.0)
   nw_mx.visible = false
   nw_mx.alpha = ((prf.NEWGAME == true)? 220 : 0)
   if (prf.CROPSNAPS) {
      nw_mx.set_pos(selectorscale*padding,selectorscale*(padding-verticalshift+height*7.0/8.0),width*selectorscale/8.0,height*selectorscale/8.0)
   }

   local donez = obj.add_image("completed.png",selectorscale*padding,selectorscale*(padding-verticalshift),selectorscale*width*0.8,selectorscale*height*0.8)
   donez.visible = false
   donez.preserve_aspect_ratio = false

   local favez = obj.add_image("starred.png",selectorscale*(padding+width/2),selectorscale*(padding+height/2-verticalshift),selectorscale*width/2,selectorscale*height/2)
   favez.visible = false
   favez.preserve_aspect_ratio = false

   local logosurf1 = obj.add_clone (logosurf1)
   logosurf1.preserve_aspect_ratio = true
   logosurf1.visible = true

   if (!prf.CROPSNAPS)
      logosurf1.set_pos (selectorscale*padding*0.5,selectorscale*(padding*0.4*0.5-verticalshift),selectorscale*(width+padding),selectorscale*(height*0.5+padding))
   else
      logosurf1.set_pos (selectorscale*padding,selectorscale*padding,selectorscale*width,selectorscale*width*logosh_h/logosh_w)

   local logoz = obj.add_clone (loshz)
   logoz.preserve_aspect_ratio = true
   
	if (!prf.CROPSNAPS)
      logoz.set_pos (selectorscale*padding,selectorscale*(padding*0.6-verticalshift),selectorscale*width,selectorscale*height*0.5)
   else
      logoz.set_pos (selectorscale*(padding+width*logomargin/logosh_w),selectorscale*(padding+width*(15/20.0)*logomargin/logosh_w),selectorscale*width*logo_w/logosh_w,selectorscale*height*logo_h/logosh_w)
   
   loshz.alpha = 150  
   loshz.preserve_aspect_ratio = true
   loshz.set_rgb(0,0,0)

   tilesTablePosX.push((width+padding) * (i/rows) + padding + obj.width*0.5)
   tilesTablePosY.push((width+padding) * (i%rows) + padding + carrierT.y + verticalshift + obj.height*0.5)
   tilesTableZoom.push ([0.0,0.0,0.0,0.0,0.0])

   obj.preserve_aspect_ratio = false
   
   tilesTable.push (obj)
   snapzTable.push (snapz)
   logozTable.push (logoz)
   loshzTable.push (loshz)
   favezTable.push (favez)
   donezTable.push (donez)
   sh_hzTable.push (sh_hz)
   sh_vzTable.push (sh_vz)
   nw_mxTable.push (nw_mx)
   vidszTable.push (vidsz)
   vid2zTable.push (vid2z)
   gradzTable.push (gradz)
   bd_mxTable.push (bd_mx)
   glomxTable.push (glomx)
}

surfacePos = 0.5

/// Foreground panel surface  
local fg_surface = fe.add_clone(bg_surface)
fg_surface.zorder = 0

//fg_surface.alpha = 120
//fg_surface.set_pos(bgT.x,bgT.y,bgT.w,bgT.w)

/// Data surface construction  

local data_surface = fe.add_surface (flw,flh)

local filterdata = data_surface.add_text ("[FilterName]",0,flh-footer_h,footermargin,footer_h)
filterdata.align = Align.Centre
filterdata.set_rgb( 255, 255, 255)
filterdata.word_wrap = true
filterdata.charsize = (prf.LOWRES ? 35*scalerate/0.711 : 25*scalerate/0.711)
filterdata.visible = true
filterdata.font = guifont
filterdata.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
//filterdata.set_bg_rgb (200,10,10)

local filternumbers = data_surface.add_text ("[ListEntry]\n[ListSize]",flw-footermargin,flh-footer_h,footermargin,footer_h)
filternumbers.align = Align.Centre
filternumbers.set_rgb( 255, 255, 255)
filternumbers.word_wrap = true
filternumbers.charsize = (prf.LOWRES ? 35*scalerate/0.711 : 25*scalerate/0.711)
filternumbers.visible = true
filternumbers.font = guifont
filternumbers.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)

local separatorline = data_surface.add_image("white.png",flw-footermargin+footermargin*0.3, flh-footer_h + footer_h*0.5,footermargin*0.4,1)
separatorline.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)


local blsize = {
   mini = 45 * scalerate,
   catp = 110 * scalerate,
   subt = 35 * scalerate,
   posy = 137 * scalerate,
   manu = 145 * scalerate,
   dath = 25 * scalerate

}

if (prf.LOWRES) {
   blsize = {
      mini = 60 * scalerate,
      catp = 150 * scalerate,
      subt = 45 * scalerate,
      posy = 180 * scalerate,
      manu = 150 * scalerate,
      dath = 40 * scalerate
   }
}

// category image
local game_catpicT = {
	x = 30 * scalerate,
	y = 20 * scalerate,
	w = blsize.catp,
	h = blsize.catp
}

// players image, controller image, button image 
local game_plypicT = {
	x = blsize.catp + 2.0 * game_catpicT.x,
	y = blsize.posy,
	w = blsize.mini,
	h = blsize.mini
}

local game_ctlpicT = {
	x = game_plypicT.x + (blsize.mini + 10 * scalerate),
	y = game_plypicT.y,
	w = blsize.mini,
	h = blsize.mini
}

local game_butpicT = {
	x = game_plypicT.x + 2 * (blsize.mini + 10 * scalerate),
	y = game_plypicT.y,
	w = blsize.mini * 1.25,
	h = blsize.mini
}

// main game category
local game_maincatT = {
	x = 20 * scalerate,
	y = header_h - 20 * scalerate - blsize.subt,
	w = game_plypicT.x - 2 * 20 * scalerate,
	h = blsize.subt
}


// right side: manufacturer and year 
local game_manufacturerpicT = {
	x = flw - 2 * blsize.manu - 30 * scalerate,
	y = (prf.LOWRES ? 20*scalerate : 10 * scalerate),
	w = 2 * blsize.manu,
	h = blsize.manu
}
local game_yearT = {
	x = game_manufacturerpicT.x,
	y = header_h - 20 * scalerate - blsize.dath,
	w = game_manufacturerpicT.w,
	h = blsize.dath
}

// game main name and subname
local game_mainnameT = {
	x = game_plypicT.x,
	y = game_catpicT.y,
	w = flw - game_plypicT.x - game_manufacturerpicT.w - 30*scalerate - 5 * scalerate,
	h = game_catpicT.h
}

local game_subnameT = {
	x = game_butpicT.x + game_butpicT.w + 15 * scalerate,
	y = game_maincatT.y,
	w = flw - game_butpicT.x - game_butpicT.w - 15 *scalerate - game_manufacturerpicT.w - 30*scalerate - 5 * scalerate,
	h = blsize.subt
}

local bwtoalpha = fe.add_shader( Shader.Fragment, "bwtoalpha.glsl" )
bwtoalpha.set_texture_param( "texture")

local txtoalpha = fe.add_shader( Shader.Fragment, "txtoalpha.glsl" )
txtoalpha.set_texture_param( "texture")

for (local i = 0; i < data_stacksize; i++){

	local game_catpic = data_surface.add_image("white.png",game_catpicT.x, game_catpicT.y, game_catpicT.w, game_catpicT.h)
	game_catpic.smooth = false
	game_catpic.preserve_aspect_ratio = true
	game_catpic.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_catpic.shader = bwtoalpha
	//game_catpic.fix_masked_image()

	local game_butpic = data_surface.add_image("white.png",game_butpicT.x, game_butpicT.y, game_butpicT.w, game_butpicT.h)
	game_butpic.smooth = true
	game_butpic.preserve_aspect_ratio = true
	game_butpic.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_butpic.shader = bwtoalpha
	// game_catpic.mipmap = 1
	
	local game_plypic = data_surface.add_image("white.png",game_plypicT.x, game_plypicT.y, game_plypicT.w, game_plypicT.h)
	game_plypic.smooth = true
	game_plypic.preserve_aspect_ratio = true
	game_plypic.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_plypic.shader = bwtoalpha
	// game_plypic.mipmap = 1

	local game_ctlpic = data_surface.add_image("white.png",game_ctlpicT.x, game_ctlpicT.y, game_ctlpicT.w, game_ctlpicT.h)
	game_ctlpic.smooth = true
	game_ctlpic.preserve_aspect_ratio = true
	game_ctlpic.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_ctlpic.shader = bwtoalpha
	// game_ctlpic.mipmap = 1

	local game_maincat = data_surface.add_text("[!maincategory]",game_maincatT.x,game_maincatT.y,game_maincatT.w,game_maincatT.h)
	game_maincat.align = Align.MiddleCentre
	game_maincat.word_wrap = true
	game_maincat.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_maincat.charsize = (game_maincatT.h - 10*scalerate)/0.711
	game_maincat.font = guifontcondensed
	game_maincat.alpha = 255
	game_maincat.margin = 0
	game_maincat.line_spacing = 0.8
//	game_maincat.set_bg_rgb (255,0,0)
	

	local game_mainname = data_surface.add_text( "[!gamename2]", game_mainnameT.x, game_mainnameT.y, game_mainnameT.w, game_mainnameT.h )
	game_mainname.align = Align.MiddleLeft
	game_mainname.word_wrap = true
	game_mainname.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_mainname.charsize = (game_mainnameT.h - 10*scalerate)*0.5/0.711
	game_mainname.line_spacing = 0.670000068
	game_mainname.margin = 0
	game_mainname.font = guifont
	game_mainname.alpha = 255
//	game_mainname.set_bg_rgb(200,0,0)
	game_mainname.visible = true

	local game_subname = data_surface.add_text( "[!gamesubname]", game_subnameT.x, game_subnameT.y, game_subnameT.w, game_subnameT.h )
	game_subname.align = Align.TopLeft
	game_subname.word_wrap = false
	game_subname.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_subname.charsize = game_subnameT.h/0.711
	game_subname.font = guifont
	game_subname.alpha = 255
	game_subname.margin = 0
//	game_subname.set_bg_rgb(200,100,0)


	local game_manufacturerpic = data_surface.add_image("white.png",game_manufacturerpicT.x - i*200*0, game_manufacturerpicT.y, game_manufacturerpicT.w, game_manufacturerpicT.h)
	// game_manufacturerpic.mipmap = 1
	game_manufacturerpic.smooth = true
	game_manufacturerpic.preserve_aspect_ratio = false
	game_manufacturerpic.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_manufacturerpic.shader = bwtoalpha

	local game_year = data_surface.add_text( "© [Year]  ", game_yearT.x, game_yearT.y, game_yearT.w, game_yearT.h)
	game_year.align = Align.TopCentre
	game_year.set_rgb( 255, 255, 255)
	game_year.word_wrap = false
	game_year.charsize = game_yearT.h/0.711
	game_year.visible = true
	game_year.font = guifont
	game_year.margin = 0
	game_year.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
//	game_year.set_bg_rgb(200,000,100)
	
	dat.var_array.push(0)
	dat.alphapos.push (1)
	dat.cat_array.push(game_catpic)
	dat.but_array.push (game_butpic)
	dat.ply_array.push (game_plypic)
	dat.ctl_array.push (game_ctlpic)
	dat.mainctg_array.push(game_maincat)
	dat.manufacturer_array.push(game_manufacturerpic)
	dat.gamename_array.push(game_mainname)
	dat.gamesubname_array.push(game_subname)
	dat.gameyear_array.push(game_year)
}

// Creation of data shadow

local sh_scaler = (vertical ? 400.0 / data_surface.width : 400.0 / data_surface.height)

local shader_tx = {
   h = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
   v = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
}

shader_tx.v.set_texture_param( "texture")
shader_tx.v.set_param("kernelData",9,3.0)
shader_tx.v.set_param("offsetFactor",0.000,1.0/(flh*sh_scaler))

shader_tx.h.set_texture_param( "texture")
shader_tx.h.set_param("kernelData",9,3.0)
shader_tx.h.set_param("offsetFactor",1.0/(flw*sh_scaler),0.000)

//local data_surface_sh1 = fe.add_clone(data_surface)

local data_surface_sh = fe.add_surface(data_surface.width * sh_scaler , data_surface.height * sh_scaler)
local data_surface_sh1 = data_surface_sh.add_clone(data_surface)
data_surface_sh1.set_pos (0 , 0 , data_surface.width * sh_scaler , data_surface.height * sh_scaler)

data_surface_sh.set_rgb(0,0,0)
data_surface_sh1.set_rgb(0,0,0)

/*
data_surface_sh1.visible = false
data_surface_sh1 = data_surface_sh.add_clone(data_surface_sh1)
data_surface_sh1.visible = true
*/

//if (prf.DATASHADOWSMOOTH) data_surface_sh.shader = shadowshader
if (prf.DATASHADOWSMOOTH){
   data_surface_sh.shader = shader_tx.v
   data_surface_sh1.shader = shader_tx.h
}

data_surface_sh.alpha = themeT.themeshadow

//data_surface_sh.zorder = data_surface.zorder - 1
data_surface_sh.zorder =-1

data_surface_sh.set_pos(4*scalerate,7*scalerate,data_surface.width,data_surface.height)

/// Frosted glass surface  

local frost_picsize = 96.0
local frost_picw = null
local frost_pich = null

if (!vertical){
	frost_picw = frost_picsize
	frost_pich = frost_picsize * flh/flw
}
else {
	frost_picw = frost_picsize * flw/flh
	frost_pich = frost_picsize
}

local displayAR = ScreenWidth*1.0/ScreenHeight
local screenAR = scrw*1.0/scrh
local layoutAR = flw*1.0/flh
if (rotate90) displayAR = 1.0/displayAR

local frost_picT = {
	x = null,
	y = null,
	w = null,
	h = null
}

if (displayAR > layoutAR){
	frost_picT.h = frost_pich
	frost_picT.w = frost_pich*displayAR
	frost_picT.x = (frost_picw - frost_picT.w)*0.5
	frost_picT.y = 0
}
else{
	frost_picT.w = frost_picw
	frost_picT.h = frost_picw/displayAR
	frost_picT.x = 0
	frost_picT.y = (frost_pich - frost_picT.h)*0.5
}

local frost_surf1 = null
local flipshader = null
local frost_surf2 = null
local frost_pic = null
local shader_fr = null
local frost_surface = null
local frost_top = null
local frost_scaler = null

if (prf.FROSTEDGLASS){
   frost_scaler = frost_picw*1.0/flw
   
   frost_surface = fe.add_surface(flw*frost_scaler,(flh-header_h-footer_h)*frost_scaler)
	frost_surf1 = frost_surface.add_surface(frost_picw,frost_pich)
	frost_pic = frost_surf1.add_image("transparent.png",frost_picT.x,frost_picT.y,frost_picT.w,frost_picT.h)

	flipshader = fe.add_shader( Shader.Vertex, "flipper_v.glsl" )
	flipshader.set_texture_param( "texture")
	flipshader.set_param("rotation",realrotation)

	//frost_surf2 = fe.add_surface(frost_picw,frost_pich)

	// TEST frost_surface = fe.add_surface(flw,flh-header_h2-footer_h)

	shader_fr = {
      v = fe.add_shader( Shader.VertexAndFragment, "flipper_v.glsl","gauss_kernsigma_o.glsl" )
      h = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
   }
   
	shader_fr.v.set_texture_param( "texture")
	shader_fr.v.set_param("kernelData", 13.0, 2.5)
   shader_fr.v.set_param("rotation",realrotation)
   shader_fr.v.set_param("offsetFactor", rotate90 ? 1.0/frost_picT.h : 0.0, rotate90 ? 0.0 : 1.0/frost_picT.h)
 
	shader_fr.h.set_texture_param( "texture")
	shader_fr.h.set_param("kernelData", 13.0, 2.5)
	shader_fr.h.set_param("offsetFactor", 1.0/frost_picw, 0.000)

	frost_surf1.set_pos(0,-header_h*frost_scaler,flw*frost_scaler,flh*frost_scaler)

	frost_surface.set_pos(0,header_h,flw,flh-header_h-footer_h)

	frost_surface.alpha = 0
}

function frostshaders (turnon){
		if (turnon){
			frost_top.shader = flipshader
         frost_top.visible = true
			frost_surf1.shader = shader_fr.h
			frost_pic.shader = shader_fr.v
         
		}
		else{
			frost_top.shader = noshader
         frost_top.visible = false
			frost_surf1.shader = noshader
			frost_pic.shader = noshader			
		}
}



/// Controls Overlays (Listbox)  

local overlay_charsize = (prf.LOWRES ? floor( 65*scalerate ) : floor( 50*scalerate ))
local overlay_rowsize = (prf.LOWRES ? (overlay_charsize*2.5) : (overlay_charsize*3))
local overlay_labelsize = (overlay_rowsize * 1)
local overlay_labelcharsize = overlay_charsize * 1

local overlay_rows = floor((flh-header_h-footer_h - overlay_labelsize)/overlay_rowsize)

// sfondo dell'area con le scritte
local overlay_background = fe.add_text ("", 0 , header_h, flw, flh-header_h-footer_h)
overlay_background.set_bg_rgb(200,200,200)
overlay_background.bg_alpha = 15

local overlay_listbox = fe.add_listbox( 0, header_h+overlay_labelsize, flw, flh-header_h-footer_h-overlay_labelsize )
overlay_listbox.rows = overlay_rows
overlay_listbox.charsize = overlay_charsize
overlay_listbox.bg_alpha = 0
overlay_listbox.set_rgb(themeT.themetextcolor-5,themeT.themetextcolor-5,themeT.themetextcolor-5)
overlay_listbox.set_bg_rgb( 0, 0, 0 )
overlay_listbox.set_sel_rgb( 50, 50, 50 )
overlay_listbox.set_selbg_rgb( 250,250,250 )
overlay_listbox.selbg_alpha = 255
overlay_listbox.font = guifont

local overlay_label = fe.add_text( "dummy", 0, header_h, flw, overlay_labelsize )
overlay_label.charsize = overlay_labelcharsize
overlay_label.set_rgb(themeT.themetextcolor-5,themeT.themetextcolor-5,themeT.themetextcolor-5)
overlay_label.align = Align.Centre
overlay_label.font = guifont

local shader1 = fe.add_image ("wgradient.png",0,flh-footer_h,flw,50*scalerate)

local shader2 = fe.add_image ("white.png",padding,header_h+overlay_labelsize-2,flw-2*padding,2)

local shader3 = fe.add_image ("wgradient2.png",0,header_h-50*scalerate,flw,50*scalerate)

shader1.alpha = 50
shader2.alpha = 255
shader3.alpha = 50
shader1.set_rgb(0,0,0)
shader3.set_rgb(0,0,0)

overlay_background.visible = overlay_listbox.visible = overlay_label.visible = shader1.visible = shader2.visible = shader3.visible =  false

fe.overlay.set_custom_controls( overlay_label, overlay_listbox )

function overlay_show(){
	if (prf.FROSTEDGLASS) {
		frost_surface.alpha = 255 
      frostshaders(true)
   }
	else {
		fg_surface.alpha = 255*satinrate
   }

//	if (logoshow != 0 ) cutlogo()
   overlay_background.visible = overlay_listbox.visible = overlay_label.visible = shader1.visible = shader2.visible = shader3.visible =  true
}

function overlay_hide(){
	if (prf.FROSTEDGLASS) {
		frost_surface.alpha = 0
		frostshaders(false) 
	}
	else {
		fg_surface.alpha = 0
   }

   if (prf.FROSTEDGLASS) frg.grabdither = 2
   overlay_background.visible = overlay_listbox.visible = overlay_label.visible = shader1.visible = shader2.visible = shader3.visible =  false
}




/// Context Menu  

//local overmenuwidth = (vertical ? flw * 0.7 : flh * 0.7)
local overmenuwidth = selectorwidth * 0.9
local overmenu = fe.add_image("overmenu3.png",flw*0.5-overmenuwidth*0.5,flh*0.5-overmenuwidth*0.5,overmenuwidth,overmenuwidth)
overmenu.visible = false
overmenu.alpha = 0

function overmenu_visible(){
	return ((overmenu.visible) && (flowT.overmenu[3] >= 0))
}

function overmenu_show(){
	overmenu.y = flh*0.5*0 + header_h2 + heightpadded*0.5 -overmenuwidth*0.5 - corrector * (heightpadded - padding)
	if (rows == 1 ) overmenu.y = flh*0.5*0 + header_h2 + heightpadded*0.5 - overmenuwidth*0.5 
	overmenu.x = flw*0.5 - overmenuwidth*0.5 + centercorrection
	if(prf.THEMEAUDIO) snd.wooshsound.playing=true
	overmenu.visible = true
	flowT.overmenu = startfade (flowT.overmenu , 0.095,0.0)
}

function overmenu_hide(strict){
	if(prf.THEMEAUDIO) snd.wooshsound.playing=true
	if(strict) overmenu.visible = false
	flowT.overmenu = startfade (flowT.overmenu , -0.095,-3.0)
}

/// Frosted Image Overlay  

if (prf.FROSTEDGLASS){

   if (displayAR > layoutAR){
      frost_top = fe.add_image("transparent.png",(flh/frost_pich)*frost_picT.x,0,flw*1.0*displayAR/layoutAR , flh)
      }
   else{
      frost_top = fe.add_image("transparent.png",0,(flw/frost_picw)*frost_picT.y,flw,flh -2*(flw/frost_picw)*frost_picT.y)
   }

   frost_top.preserve_aspect_ratio = false
   frost_top.visible = false
}


/// Search Module  

local search_surface = fe.add_surface(flw, flh)
local keys = null
keys = {}
local search_text = null
local key_low = 100

search_surface.preserve_aspect_ratio = true
search_surface.alpha = 255*0

//select( config.keys.selected[0], config.keys.selected[1] )

function search_toggle() {
	search_surface.alpha = ( search_surface.alpha == 0 ) ? 255: 0

	//clear text when shown
	if ( search_visible() ){ 
		if (search_text.msg == "") search_text.msg = search_base_rule + ": "
		search_clear()
	}
	
	if ((search_visible() == false) && (fe.list.search_rule == "")) {
		if (backindex != -1) {
			fe.list.search_rule == ""
			fe.list.index = backindex
			//corrector = backcorrector
			backindex = -1
		}
	}
	
}

function search_clear()
{
	s_text = ""
	search_text.msg = search_base_rule + ": "
   search_update_rule()
}

//get current visibility
function search_visible() {
	return (search_surface.alpha == 255)
}

function search_select_relative( rel_col, rel_row )
{
	search_select( key_selected[0] + rel_col, key_selected[1] + rel_row )
}

function search_select( col, row )
{
	row = ( row < 0 ) ? key_rows.len() - 1 : ( row > key_rows.len() - 1 ) ? 0 : row
	col = ( col < 0 ) ? key_rows[row].len() - 1 : ( col > key_rows[row].len() - 1 ) ? 0 : col
	local previous = key_rows[key_selected[1]][key_selected[0]].tochar()
	local selected = key_rows[row][col].tochar()
	//print( "selected: " + selected + "(" + col + "," + row + ") previous: " + previous + "(" + config.keys.selected[0] + "," + config.keys.selected[1] + ")" )
	keys[previous].set_rgb( key_low,key_low,key_low )
	keys[previous].alpha = 255
	keys[selected].set_rgb( 255,255,255 )
	keys[selected].alpha = 255
	key_selected = [ col, row ]
}

function search_type( c )
{
	if ( c == "<" )
		s_text = ( s_text.len() > 0 ) ? s_text.slice( 0, s_text.len() - 1 ) : ""
	else if ( c == "-" )
      search_clear()
	else if ( c == "~" )
	{
		//search_update_rule ()
		//backindex = -1
		if (!prf.LIVESEARCH) search_update_rule()
		search_toggle()
		return
	}
	else if (c != "_")
		s_text = s_text + c
	search_text.msg = search_base_rule + ": " + s_text 
	if (prf.LIVESEARCH) search_update_rule()
}

function search_update_rule(){
	try
	{
		local rule = search_base_rule + " contains " + recalculate (s_text)
		//fe.list.search_rule = "Title contains mario"
		//fe.list.search_rule = ""
		//fe.list.index += corrector + tilesTotal
		fe.list.index ++
		fe.list.search_rule = ( s_text.len() > 0 ) ? rule : ""
		//fe.list.index = 0
		corrector = (rows == 1 ? -1 : 0)
		if(fe.list.search_rule == ""){
			searchdata.msg = ""
			//if (backindex != -1){
				fe.list.index = backindex
				//corrector = backcorrector
			//	backindex = -1
			//}
		}
		else
		searchdata.msg = fe.list.search_rule
		
	} catch ( err ) { print( "Unable to apply filter: " + err ); }
}

function draw_osd() {
	
	//draw the search surface bg
	local bg = search_surface.add_image("kbg2.png", 0, 0, search_surface.width, search_surface.height)
	bg.alpha = 230
	
	//draw the search text object
	local osd_search = {
		x = ( search_surface.width * 0 ) * 1.0,
		y = ( search_surface.height * 0.2 ) * 1.0,
		width = ( search_surface.width * 1 ) * 1.0,
		height = ( search_surface.height * 0.1 ) * 1.0
	}
	
	search_text = search_surface.add_text(s_text, osd_search.x, osd_search.y, osd_search.width, osd_search.height)
	search_text.align = Align.Left
	search_text.font = guifont
	search_text.set_rgb( 255, 255, 255 )
	search_text.alpha = 255
	search_text.charsize = 80*scalerate
	
	
	//draw the search key objects
	foreach( key,val in key_names ) {
		
		local key_name = (key == "_") ? " " : ( key == "-" ) ? "CLR" : ( key == " " ) ? "SPC" : ( key == "<" ) ? "DEL" : ( key == "~" ) ? "DONE" : key.toupper()
		
		local textkey = search_surface.add_text( key_name, -1, -1, 1, 1 )
		textkey.font = guifont
		textkey.charsize = 80*scalerate
		
		textkey.set_rgb( key_low,key_low,key_low)
		textkey.alpha = 255
		
		keys[ key.tolower() ] <- textkey
		
	}
	
	
	//set search key positions
	local row_count = 0
	foreach ( row in key_rows )
	{
		local col_count = 0
		local osd = {
			x = ( search_surface.width * 0.1 ) * 1.0,
			y = ( search_surface.height * 0.4 ) * 1.0,
			width = ( search_surface.width * 0.8 ) * 1.0,
			height = ( search_surface.height * 0.5 ) * 1.0
		}
		//local keynumcol = (row == "- <~") ? 4 : 10
		local key_width = ( osd.width / row.len() ) * 1.0
		local key_height = ( osd.height / key_rows.len() ) * 1.0
		foreach ( char in row )
		{
			//local key_image = keys[ iii ]
			local key_image = keys[ char.tochar() ]
			local pos = {
				x = osd.x + ( key_width * col_count ),
				y = osd.y + key_height * row_count,
				w = key_width,
				h = key_height
			}
			key_image.set_pos( pos.x, pos.y, pos.w, pos.h )
			//print( "Key " + col_count + ": " + pos.x + "," + pos.y + " " + pos.w + "x" + pos.h );
			col_count++
		}
		row_count++
	}
}

draw_osd()
search_select (key_selected[0],key_selected[1])


/// History Page  

local hist_direction = 0

local hist_split_h = 0.55

local hist_titleT = {
	x = flw*hist_split_h + 15*scalerate,
	y = 0+15*scalerate,
	w = flw*(1.0 - hist_split_h)-30*scalerate,
	h = flh*0.25-30*scalerate
   transparency = 50
}

local hist_screenT = {
	x = 0,
	y = (flh-flw*hist_split_h)*0.5,
	w = flw*hist_split_h,
	h = flw*hist_split_h
}

hist_screenT.y += hist_screenT.y % 2.0
hist_screenT.w += hist_screenT.w % 2.0
hist_screenT.h += hist_screenT.h % 2.0

if (hist_screenT.h > flh){
	hist_screenT.x = (flw*hist_split_h-flh)*0.5
	hist_screenT.y = 0
	hist_screenT.x += hist_screenT.x % 2.0
	hist_screenT.w = flh
	hist_screenT.w += hist_screenT.w % 2.0
	hist_screenT.h = flh
	hist_screenT.h += hist_screenT.h % 2.0
}

local hist_textT = {
	x = flw*hist_split_h,
	y = flh*0.25,
	w = flw*(1.0-hist_split_h),
	h = flh*0.75
}

if (vertical){
	hist_titleT.x = 0
	hist_titleT.y = flh*hist_split_h
	hist_titleT.w = flw
	hist_titleT.h = flh*(1.0 - hist_split_h)*0.3

	hist_screenT.x = (flw-flh*hist_split_h)*0.5
	hist_screenT.x += hist_screenT.x % 2.0
	hist_screenT.y = 0
	hist_screenT.w = flh*hist_split_h
	hist_screenT.w += hist_screenT.w % 2.0
	hist_screenT.h = flh*hist_split_h
	hist_screenT.h += hist_screenT.h % 2.0

	if (hist_screenT.w > flw){
		hist_screenT.x = 0
		hist_screenT.y = (flh*hist_split_h - flw)*0.5
		hist_screenT.y += hist_screenT.y % 2.0
		hist_screenT.w = flw
		hist_screenT.w += hist_screenT.w % 2.0
		hist_screenT.h = flw
		hist_screenT.h += hist_screenT.h % 2.0
	}

	hist_textT.x = 0
	hist_textT.y = flh*hist_split_h + flh*(1.0 - hist_split_h)*0.3
	hist_textT.w = flw
	hist_textT.h = flh*(1.0 - hist_split_h)*0.7
}

local shadowscale = 0.025

hist_titleT.x = hist_titleT.x+hist_titleT.w*shadowscale
hist_titleT.y = hist_titleT.y+hist_titleT.h*shadowscale
hist_titleT.w = hist_titleT.w*(1-shadowscale*2)
hist_titleT.h = hist_titleT.h*(1-shadowscale*2)


local historypadding = (hist_screenT.w * 0.025)
historypadding += historypadding % 2.0

local hist_curr_rom = ""
local history_surface = fe.add_surface(flw,flh)
 
local hist_bg = history_surface.add_text ("",0,0,history_surface.width,history_surface.height)
hist_bg.set_bg_rgb(0,0,0)
hist_bg.bg_alpha = 1

local hist_white = null

if (prf.HISTORYPANEL){
   if (vertical) {
      hist_white = history_surface.add_image("white.png",0,flh*hist_split_h,hist_textT.w,flh-hist_screenT.h)
   }
   else{
      hist_white = history_surface.add_image("white.png",hist_textT.x,0,hist_textT.w,flh)
   }
   hist_white.alpha = 200
}

local hist_title = history_surface.add_image ("transparent.png",hist_titleT.x,hist_titleT.y,hist_titleT.w,hist_titleT.h)
hist_title.preserve_aspect_ratio = true

local hist_title_top = null

if (prf.HISTORYPANEL){
   hist_title_top = history_surface.add_clone (hist_title)
   hist_title_top.preserve_aspect_ratio = true

   hist_title.set_pos (hist_titleT.x-hist_titleT.w*shadowscale  ,hist_titleT.y+2*shadowscale*hist_titleT.h,hist_titleT.w*(1+shadowscale*2),hist_titleT.h*(1+shadowscale*2))
   hist_title.set_rgb(0,0,0)
   hist_title.alpha = hist_titleT.transparency
}


local hist_black = null
local hist_g1 = null
local hist_g2 = null

if (!vertical){
	hist_black = history_surface.add_image("black.png",0,0,flw*hist_split_h,flh)
	hist_g1 = history_surface.add_image("wgradient2.png",0,0,flw*hist_split_h,flh*0.5) 
	hist_g2 = history_surface.add_image("wgradient.png",0,flh*0.5,flw*hist_split_h,flh*0.5)
}
else{
	hist_black = history_surface.add_image("black.png",0,0,flw,flh*hist_split_h)
	hist_g1 = history_surface.add_image("wgradient3.png",0,0,flw*0.5,flh*hist_split_h)
	hist_g2 = history_surface.add_image("wgradient4.png",flw*0.5,0,flw*0.5,flh*hist_split_h)
}

hist_black.set_rgb (0,0,0)
hist_g1.set_rgb (0,0,0)
hist_g2.set_rgb (0,0,0)

hist_g1.alpha = hist_g2.alpha = 150
hist_black.alpha = prf.DARKPANEL ? 180 : 50

local CRTprf = null

if (prf.SCANLINEMODE == "Scanlines"){
   CRTprf = {
      aperature_type = 0.0
      hardScan = -15.0
      hardPix = -2.0
      maskDark = 0.4
      maskLight = 1.5
      saturation = 1.0
      tint = 0.0
      blackClip = 0.1
      brightMult = 1.4
      distortion = 0.2
      cornersize = 0.05
      cornersmooth = 60
      scanresample = 1.0
   }
}

if (prf.SCANLINEMODE == "Aperture"){
   CRTprf = {
      aperature_type = 3.0
      hardScan = -3.0
      hardPix = -2.0
      maskDark = 0.6
      maskLight = 1.3
      saturation = 1.0
      tint = 0.0
      blackClip = 0.1
      brightMult = 1.1
      distortion = 0.2
      cornersize = 0.05
      cornersmooth = 60
      scanresample = 1.0
   }
}

if (prf.SCANLINEMODE == "Half Resolution"){
   CRTprf = {
      aperature_type = 0.0
      hardScan = -15.0
      hardPix = -4.0
      maskDark = 0.4
      maskLight = 1.5
      saturation = 1.0
      tint = 0.0
      blackClip = 0.1
      brightMult = 1.4
      distortion = 0.2
      cornersize = 0.05
      cornersmooth = 60
      scanresample = 0.5
   }
}

if (prf.SCANLINEMODE == "None"){
   CRTprf = {
      aperature_type = 0.0
      hardScan = -3.0
      hardPix = -2.0
      maskDark = 0.4
      maskLight = 1.5
      saturation = 1.0
      tint = 0.0
      blackClip = 0.1
      brightMult = 1.0
      distortion = 0.2
      cornersize = 0.05
      cornersmooth = 60
      scanresample = 1.0
   }
}

local shader_lottes = null;
shader_lottes=fe.add_shader(Shader.VertexAndFragment,"CRTL-geom_vsh.glsl","CRTL-geom_fsh.glsl");
shader_lottes.set_param("aperature_type", CRTprf.aperature_type); // 0.0 = none, 1.0 = TV style, 2.0 = Aperture grille, 3.0 = VGA
shader_lottes.set_param("hardScan", CRTprf.hardScan);   // Hardness of Scanline 0.0 = none -8.0 = soft -16.0 = medium 
shader_lottes.set_param("hardPix", CRTprf.hardPix);     // Hardness of pixels in scanline -2.0 = soft, -4.0 = hard
shader_lottes.set_param("maskDark",CRTprf.maskDark);     // Sets how dark a "dark subpixel" is in the aperture pattern.
shader_lottes.set_param("maskLight", CRTprf.maskLight);    // Sets how dark a "bright subpixel" is in the aperture pattern
shader_lottes.set_param("saturation", CRTprf.saturation);   // 1.0 is normal saturation. Increase as needed.
shader_lottes.set_param("tint", CRTprf.tint);         // 0.0 is 0.0 degrees of Tint. Adjust as needed.
shader_lottes.set_param("blackClip", CRTprf.blackClip);   // Drops the final color value by this amount if GAMMA_CONTRAST_BOOST is defined
shader_lottes.set_param("brightMult", CRTprf.brightMult);   // Multiplies the color values by this amount if GAMMA_CONTRAST_BOOST is defined
shader_lottes.set_param("distortion", CRTprf.distortion);  // 0.0 to 0.2 seems right
shader_lottes.set_param("cornersize", CRTprf.cornersize);  // 0.0 to 0.1
shader_lottes.set_param("cornersmooth", CRTprf.cornersmooth);  // Reduce jagginess of corners
shader_lottes.set_param("vignettebase", 0.3,1.0,2.0);  // base lightness for vignette

shader_lottes.set_texture_param("texture")


local hist_text_surf = history_surface.add_surface( hist_textT.w, hist_textT.h )
hist_text_surf.set_pos (hist_textT.x, hist_textT.y )

local hist_text = hist_text_surf.add_text( "", 0,0, hist_textT.w, hist_textT.h )
hist_text.charsize = (prf.LOWRES ? 55*scalerate : (40 * scalerate > 8 ? 40*scalerate : 8))

hist_text.first_line_hint = 3
hist_text.visible = true
if (prf.HISTORYPANEL) {
   hist_text.set_rgb(themeT.themehistorytextcolor,themeT.themehistorytextcolor,themeT.themehistorytextcolor)
   hist_text_surf.set_rgb(themeT.themehistorytextcolor,themeT.themehistorytextcolor,themeT.themehistorytextcolor)
}
else {
   hist_text.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
  hist_text_surf.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
 
}

local gradshader = fe.add_shader (Shader.Fragment, "blackgrad2.glsl")
gradshader.set_texture_param( "texture")
gradshader.set_param ("limits", 40 * scalerate * 1.7 / hist_textT.h , 40 * scalerate * 5.0 / hist_textT.h)

hist_text_surf.shader = gradshader
hist_text_surf.shader = noshader

//local hist_temp = history_surface.add_image("black.png",hist_screenT.x+historypadding,hist_screenT.y+historypadding,hist_screenT.w-2.0*historypadding,hist_screenT.h-2.0*historypadding)
//hist_temp.alpha = 128

local histglow = {
   w = hist_screenT.w - 2 * historypadding
   x = hist_screenT.x + historypadding
   y = hist_screenT.y + historypadding
}

// shadow parameters
local shadow_radius = histglow.w*0.25
local shadow_downsample = 64.0/histglow.w
local shadow_enlarge = 0.97

// creation of first surface with safeguards area
local shadowsurf1 = fe.add_surface (shadow_downsample * (histglow.w + 2 * shadow_radius), shadow_downsample * (histglow.w + 2 * shadow_radius))

// add a clone of the picture to topmost surface
local hist_glow_pic = shadowsurf1.add_image("transparent.png",(shadow_radius-0.5*histglow.w*(shadow_enlarge - 1.0))*shadow_downsample,(shadow_radius-0.5*histglow.w*(shadow_enlarge - 1.0))*shadow_downsample,histglow.w*shadow_enlarge*shadow_downsample,histglow.w*shadow_enlarge*shadow_downsample)
//hist_glow_pic.mipmap = 1
hist_glow_pic.preserve_aspect_ratio = true
// creation of second surface
local shadowsurf2 = fe.add_surface (shadowsurf1.width, shadowsurf1.height)

// nesting of surfaces
shadowsurf1.visible = false
shadowsurf1 = shadowsurf2.add_clone(shadowsurf1)
shadowsurf1.visible = true

shadowsurf2.visible = false
shadowsurf2 = history_surface.add_clone(shadowsurf2)
shadowsurf2.visible = true

local blursizeglow = {
   x = 1.0/shadowsurf2.width
   y = 1.0/shadowsurf2.height
}

local kerneldat = {
   size = shadow_downsample * (shadow_radius * 2) + 1
   sigma = shadow_downsample * shadow_radius * 0.3
}

local shadowshader = {
   h = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o_glow.glsl" )
   v = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o_glow.glsl" )
}
shadowshader.h.set_texture_param("texture")
shadowshader.h.set_param("kernelData", kerneldat.size, kerneldat.sigma)
shadowshader.h.set_param("offsetFactor", blursizeglow.x, 0.0)
shadowsurf1.shader = shadowshader.h
shadowsurf1.shader = noshader

shadowshader.v.set_texture_param("texture")
shadowshader.v.set_param("kernelData", kerneldat.size, kerneldat.sigma)
shadowshader.v.set_param("offsetFactor", 0.0, blursizeglow.y)
shadowsurf2.shader = shadowshader.v
shadowsurf2.shader = noshader

shadowsurf2.set_pos (histglow.x-shadow_radius,histglow.y-shadow_radius, histglow.w + 2 * shadow_radius , histglow.w + 2 * shadow_radius)

local hist_screen_ar = hist_screenT.w * 1.0 / hist_screenT.h 

local hist_screensurf = history_surface.add_surface (hist_screenT.w-2.0*historypadding,hist_screenT.h-2.0*historypadding)
hist_screensurf.set_pos(hist_screenT.x+historypadding,hist_screenT.y+historypadding)

local hist_screen = hist_screensurf.add_clone(hist_glow_pic) 
hist_screen.set_pos(0,0,hist_screenT.w-2.0*historypadding,hist_screenT.h-2.0*historypadding)
hist_screen.preserve_aspect_ratio = true
if (!prf.AUDIOVIDHISTORY) hist_screen.video_flags = Vid.NoAudio
hist_screen.shader = shader_lottes
hist_screen.shader = noshader


history_surface.visible = false
history_surface.alpha = 0

function history_updatesnap(){
	hist_screen.file_name = fe.get_art ("snap")
	hist_screen.shader = shader_lottes
   shadowsurf1.shader = shadowshader.h
   shadowsurf2.shader = shadowshader.v

	hist_screen.width = hist_screensurf.subimg_width;
   hist_screen.height = hist_screensurf.subimg_height;

   hist_screen.shader.set_param("vert", (hist_screen.texture_width >= hist_screen.texture_height ? 0.0 : 1.0));
   hist_screen.shader.set_param("color_texture_sz", hist_screen.texture_width*CRTprf.scanresample, hist_screen.texture_height*CRTprf.scanresample);
   hist_screen.shader.set_param("color_texture_pow2_sz", hist_screen.texture_width*CRTprf.scanresample, hist_screen.texture_height*CRTprf.scanresample);

}

function history_updatetext(){
   hist_title.file_name = fe.get_art ("wheel")
   hist_text_surf.shader = gradshader

	local sys = split( fe.game_info( Info.System ), ";" )
	local rom = fe.game_info( Info.Name )

	//
	// we only go to the trouble of loading the entry if
	// it is not already currently loaded
	//
	if ( hist_curr_rom != rom )
	{
		hist_curr_rom = rom
		local alt = fe.game_info( Info.AltRomname )
		local cloneof = fe.game_info( Info.CloneOf )

		local lookup = get_history_offset( sys, rom, alt, cloneof )
		
		if ( lookup >= 0 )
		{
			//fe.overlay.splash_message(lookup + " " + my_config)
			hist_text.first_line_hint = 3
			try {
				hist_text.msg = get_history_entry( lookup, my_config )
				} catch ( err ) { hist_text.msg = "There was an error loading game data, please check history.dat preferences in the layout options"; }
		}
		else
		{
			if ( lookup == -2 )
				hist_text.msg = "Index file not found. Try generating an index from the history.dat plug-in configuration menu."
			else	
				hist_text.msg = "Unable to locate: "
					+ rom
		}
	}
}

function history_show(h_startup)
{
   if ((prf.AUDIOVIDSNAPS) && (prf.THUMBVIDEO)) vidszTable[newfocusindex].video_flags = Vid.NoAudio

   history_updatesnap()
   history_updatetext()

   if (h_startup) {
   	history_surface.visible=true
	   flowT.history = startfade (flowT.history,0.05,3.0)
  	   flowT.histtext = startfade (flowT.histtext,0.05,-3.0)
  	   flowT.data = startfade (flowT.data,-0.08,-3.0)
  	   flowT.fg = startfade (flowT.fg,0.08,-3.0)
      flowT.historyscroll = [0.5,0.5,0.5,0.0,0.0]
   }
}


function history_hide() {
	//history_surface.visible = false
   if ((prf.AUDIOVIDSNAPS) && (prf.THUMBVIDEO)) vidszTable[newfocusindex].video_flags = Vid.Default

	flowT.history = startfade (flowT.history,-0.05,-3.0)
  	flowT.histtext = startfade (flowT.histtext,-0.5,0.0)
   flowT.data = startfade (flowT.data,0.06,3.0)
  	flowT.fg = startfade (flowT.fg,-0.06,3.0)
}

function history_visible() {
	return ((history_surface.visible) && (flowT.history[3] >= 0))
}

function on_scroll_up() {
	hist_text.first_line_hint--
}

function on_scroll_down() {
	hist_text.first_line_hint++
}

function history_exit () {
//	hist_title.file_name = "transparent.png"
//	hist_screen.file_name = "transparent.png"
	history_hide()
}

function cutlogo() {
	logoshow = 0
	fg_surface.alpha = 0
	data_surface_sh.alpha = themeT.themeshadow
	data_surface.alpha = 255
	aflogo_surface.alpha = 0
}

// Fade helper functions

function fadeupdate(fadearray){
   local t_counter = fadearray[0]
   local t_value = fadearray[1]
   local t_starter = fadearray[2]
   local t_increaser = fadearray[3]
   local t_easer = fadearray[4]

   t_counter = t_counter + t_increaser 

   if (t_easer == 0)
      t_value = t_counter
   else if (t_easer > 0)
      t_value = t_starter + pow (t_counter-t_starter,t_easer)
   else if (t_easer < 0)
      t_value = t_starter + 1 - pow (1.0 - t_counter + t_starter, -1*t_easer)

   return ([t_counter,t_value,t_starter,t_increaser,t_easer])
}

function checkfade(fadearray) {
   return (fadearray[3] != 0)
}

function startfade (fadearray,t_increaser,t_easer) {
   local t_data = fadearray[1]
   return ([t_data,t_data,t_data,t_increaser,t_easer])
}

function history_changegame(direction){
   flowT.historyscroll = startfade (flowT.historyscroll,0.0751,0.0)
   flowT.historyblack = startfade (flowT.historyblack,flowT.historyscroll[3]*2.0,0.0)
   flowT.historydata = startfade (flowT.historydata,0.101,0.0)
   scrollreset = true
   hist_direction = direction
}


/// Layout fades  

function layoutfadein () {
   if (prf.SPLASHON){
      flowT.fg = [1.0,1.0,1.0,-0.011,1.0]
      flowT.data = [0.0,0.0,0.0,0.011,1.0]
      flowT.logo = [1.0,1.0,1.0,-0.017,1.0]
   }
   else {
      flowT.fg = [1.0,1.0,1.0,-0.016,-1.0]
      flowT.data = [0.0,0.0,0.0,0.016,-1.0]
      flowT.logo = [1.0,1.0,1.0,-0.02,1.0]   
   }
}

data_surface.alpha = data_surface_sh.alpha = 0
fg_surface.alpha = 255

// TEST  XXX if ((!prf.AMENABLE) || (!prf.AMSTART)) layoutfadein ()

/// Attract mode  
local attract = {
   start = true
  // updatesnap = false
   rolltext = false
   gametimer = false
   starttimer = false

   scanrows = 180.0
   scansize = 5

   textshadow = 80
   game_interval = 1000 * prf.AMCHANGETIMER
   attract_interval = 1000 * prf.AMTIMER
   timer = fe.layout.time
   w = 0 
   nw = 0 
   x = 0 
   y = 0 
   msg = prf.AMMESSAGE
   sound = prf.AMSOUND
}

// If the screen resolution is so low that 5 pixels per scanline would not fit, 
// pixels per scanlines are calculated as integer and no rescaling is applied.
// otherwise scanlines are 5 pixel tall and image is 900x900 and rescaled to fit
// the actual screen resolution (to improve performance)

if (attract.scansize <= ceil (bgT.w/attract.scanrows)){
   attract.nw = attract.scansize * attract.scanrows
   attract.w = bgT.w * 1.01
   attract.x = bgT.x - bgT.w * 0.005
   attract.y = bgT.y - bgT.w * 0.005
}
else {
   attract.scansize = ceil (bgT.w/attract.scanrows)
   attract.nw = attract.scansize * attract.scanrows
   attract.w = attract.nw
   attract.x = bgT.x - (attract.nw - bgT.w)*0.5
   attract.y = bgT.y - (attract.nw - bgT.w)*0.5   
}


local attract_surface = null
local attract_snap = null
local attract_black = null
local attract_text_surface = null
local attract_text = null
local attract_text2 = null

local attract_fade = null
local attract_vignette = null
local shader_2_lottes = null

function attractkick(){
   if (history_visible()) history_hide()
   if (overmenu_visible()) overmenu_hide(true)
   attract.start = true
   attract.starttimer = false
   attract_surface.visible = true
   attract_text.visible = attract_text2.visible = true
   attract_snap.shader = shader_2_lottes

   flowT.attract = startfade (flowT.attract, 0.1,0.0)
   flowT.logo = startfade (flowT.logo,0.1,0.0)
   flowT.fg = startfade (flowT.fg,0.1,0.0)
}

function attractupdatesnap(){
   attract_snap.file_name = fe.get_art("snap",fe.list.size*rand()/RAND_MAX)
   // attract_snap.file_name = fe.get_art("snap")
   // print (attract_snap.texture_width + " " + attract_snap.texture_height + "\n\n")

   if (attract_snap.texture_width >= attract_snap.texture_height){
      attract_snap.subimg_y = attract_snap.texture_height * 0.5 - attract.scanrows * 0.5
      attract_snap.subimg_height = attract.scanrows
      attract_snap.subimg_x = attract_snap.texture_width * 0.5 - attract.scanrows * 0.5 * ((attract_snap.texture_width * 3.0/4.0)/attract_snap.texture_height)
      attract_snap.subimg_width = attract.scanrows * ((attract_snap.texture_width * 3.0/4.0)/attract_snap.texture_height)
   }
   else
   {
      attract_snap.subimg_x = attract_snap.texture_width * 0.5 - attract.scanrows * 0.5
      attract_snap.subimg_width = attract.scanrows
      attract_snap.subimg_y = attract_snap.texture_height * 0.5 - attract.scanrows * 0.5 * ((attract_snap.texture_height * 3.0/4.0)/attract_snap.texture_width)
      attract_snap.subimg_height = attract.scanrows * ((attract_snap.texture_height * 3.0/4.0)/attract_snap.texture_width)
   }
   // print (attract_snap.texture_width + " " + attract_snap.texture_height + "\n")
   // print (attract_snap.subimg_x + " " + attract_snap.subimg_y + " "+attract_snap.subimg_width + " " + attract_snap.subimg_height+"\n")

   shader_2_lottes.set_param("vert", (attract_snap.texture_width >= attract_snap.texture_height ? 0.0 : 1.0))
   shader_2_lottes.set_param("color_texture_sz", attract_snap.texture_width, attract_snap.texture_height)
   shader_2_lottes.set_param("color_texture_pow2_sz", attract_snap.texture_width, attract_snap.texture_height)
}

if (prf.AMENABLE){

   shader_2_lottes = fe.add_shader(Shader.VertexAndFragment,"CRTL-geom_vsh.glsl","CRTL-geom_fsh.glsl");


   attract_surface = fe.add_surface (attract.nw,attract.nw)
   attract_surface.set_pos(attract.x,attract.y,attract.w,attract.w)
   attract_snap = attract_surface.add_image("abg.jpg",0,0,attract.nw,attract.nw)
   attract_snap.preserve_aspect_ratio = false

   attract_black = attract_surface.add_text("",0,0,attract.nw,attract.nw)
   attract_black.set_bg_rgb(0,0,0)
   attract_black.bg_alpha = 0

   //attract_text_surface = fe.add_surface (attract.w,attract.w)
   //attract_text_surface.set_pos(attract.x,attract.y)

   if (prf.SPLASHON) {
      attract_text = fe.add_text(attract.msg,attract.x,attract.y-attract_surface.y+flh-140*scalerate,attract_surface.width,140*scalerate)
   }
   else {
      attract_text = fe.add_text(attract.msg,attract.x,attract.y,attract.w,attract.w)
   }

   attract_text.charsize = 72 * scalerate
   attract_text.font = guifont
   attract_text.set_rgb (0,0,0)
   attract_text.alpha = attract.textshadow

   attract_text2 = fe.add_text(attract.msg,attract_text.x,attract_text.y-10*scalerate,attract_text.width,attract_text.height)
   
   attract_text2.charsize = 70*scalerate
   attract_text2.font = guifont
   attract_text2.set_rgb(255,255,255)

   attract_fade = attract_surface.add_image("abg.jpg",0,0,attract.nw,attract.nw)
   attract_fade.alpha = 80
   attract_fade.blend_mode = BlendMode.Add

   attract_vignette = attract_surface.add_image("vignette.png",0,0,attract.nw,attract.nw)
//   attract_vignette.alpha = 80


   attract_snap.shader = shader_2_lottes
//   attract_snap.shader = noshader

   //fg_surface.visible = false


   shader_2_lottes.set_param("aperature_type", 0.0); // 0.0 = none, 1.0 = TV style, 2.0 = Aperture grille, 3.0 = VGA
   shader_2_lottes.set_param("hardScan", -16.0);   // Hardness of Scanline 0.0 = none -8.0 = soft -16.0 = medium 
   shader_2_lottes.set_param("hardPix", -2.0);     // Hardness of pixels in scanline -2.0 = soft, -4.0 = hard
   shader_2_lottes.set_param("maskDark",0.65);     // Sets how dark a "dark subpixel" is in the aperture pattern.
   shader_2_lottes.set_param("maskLight", 1.35);    // Sets how dark a "bright subpixel" is in the aperture pattern
   shader_2_lottes.set_param("saturation", 1.0);   // 1.0 is normal saturation. Increase as needed.
   shader_2_lottes.set_param("tint", 0.0);         // 0.0 is 0.0 degrees of Tint. Adjust as needed.
   shader_2_lottes.set_param("blackClip", 0.3);   // Drops the final color value by this amount
                                                      // if GAMMA_CONTRAST_BOOST is defined
   shader_2_lottes.set_param("brightMult", 2.0);   // Multiplies the color values by this amount
                                                      // if GAMMA_CONTRAST_BOOST is defined
   shader_2_lottes.set_param("distortion", 0.2);  // 0.0 to 0.2 seems right
   shader_2_lottes.set_param("cornersize", 0.05);  // 0.0 to 0.1
   shader_2_lottes.set_param("cornersmooth", 60);  // Reduce jagginess of corners
   shader_2_lottes.set_param("vignettebase", 0.0,1.0,3.0); 

}

if (prf.AMENABLE){
   if (prf.AMSTART) {
      attract_surface.alpha = 255
      attract_text.alpha = attract.textshadow
      attract_text2.alpha = 255
      attract.start = true
   }
   else {
      attract_snap.file_name = "transparent.png"
      attract_snap.shader = noshader
      attract_surface.visible = false
      attract_text.visible = attract_text2.visible = false
      attract_surface.alpha = 0
      attract_text.alpha = attract_text2.alpha = 0
      if(prf.AMTUNE != "") snd.attracttune.playing=false
      attract.start = false
      attract.timer = fe.layout.time
      attract.starttimer = true
   }
}


/// Splash Screen  

//local aflogo_surface = fe.add_surface(flw,flh)

// adds logo image to the logo surface
local aflogo = fe.add_image (prf.SPLASHLOGOFILE,0,0,flw,flh)
aflogo.visible = false

local aflogoT = {
	w = flw,
	h = flh,
	x = 0,
	y = 0,
	ar = aflogo.texture_width*1.0 / aflogo.texture_height
}

if (aflogoT.ar >= flw/(flh*1.0)){
	aflogoT.w = flw
	aflogoT.h = aflogoT.w / aflogoT.ar*1.0
	aflogoT.y = - (aflogoT.h - flh)*0.5
	aflogoT.x = 0
}
else {
	aflogoT.h = flh
	aflogoT.w = aflogoT.h * aflogoT.ar
	aflogoT.y = 0
	aflogoT.x = - (aflogoT.w - flw)*0.5
}

local aflogo_surface = fe.add_image (prf.SPLASHLOGOFILE,aflogoT.x,aflogoT.y,aflogoT.w,aflogoT.h)

if (!prf.SPLASHON) aflogo_surface.visible = false


/// Blanker for custom resolution  

local blanker = {
   bl1 = null
   bl2 = null
}

if (prf.CUSTOMSIZE != ""){

	if (displayAR > layoutAR){
		blanker.bl1 = fe.add_image("black.png",(flh/frost_pich)*frost_picT.x,0,-(flh/frost_pich)*frost_picT.x,flh)
		blanker.bl2 = fe.add_image("black.png",flw,0,-(flh/frost_pich)*frost_picT.x,flh)
	}
	else{
		blanker.bl1 = fe.add_image("black.png",0,(flw/frost_picw)*frost_picT.y,flw,-(flw/frost_picw)*frost_picT.y)
		blanker.bl2 = fe.add_image("black.png",0,flh,flw,-(flw/frost_picw)*frost_picT.y)
	}


}

/// Layout fade from black  

local layoutblacker = fe.add_image("black.png",0,0,flw,flh)

flowT.blacker = [1.0,1.0,1.0,-0.09,1.0]



/// FPS MONITOR  

local fps = {
   monitor = null
   monitor2 = null
   x0 = null
   tick000 = null
   tickinterval = 10
}


if (prf.FPSON){
fps.monitor = fe.add_text ("",fe.layout.width*0.5-75*scalerate,0,150*scalerate,80*scalerate)
fps.monitor.set_bg_rgb (50,50,50)
fps.monitor.bg_alpha = 200
fps.monitor.set_rgb (255,255,255)
fps.monitor.charsize = 50*scalerate
fps.monitor.zorder = 20000

fps.monitor2 = fe.add_text ("",0,0,10,10)
fps.monitor2.set_bg_rgb (255,0,0)
fps.monitor2.visible = true

fps.tick000 = 0
fps.x0 = 0

fe.add_ticks_callback(this,"monitortick")
}

function monitortick(tick_time){

	fps.monitor2.x ++
	if (fps.monitor2.x - fps.x0 == fps.tickinterval) {
		fps.monitor.msg = fps.tickinterval*1000/(tick_time - fps.tick000)
		fps.monitor2.y = (flh/60)*(60 - fps.tickinterval*1000/(tick_time - fps.tick000))
      fps.tick000 = tick_time
		fps.x0 = fps.monitor2.x
	}
	if (fps.monitor2.x >= fe.layout.width) {
		fps.monitor2.x = 0
		fps.x0 = 0
		fps.tick000=0
	}

}

/// Pre-Transition functions for labels jumps  

function gamesorter( offset ) {
   if (fe.filters.len() > 0){

      if (fe.filters[fe.list.filter_index].sort_by == Info.Year){
         local s = fe.game_info( Info.Year, offset )
         s = s.slice (0,3)+"x"
         return s
      }
      else if (fe.filters[fe.list.filter_index].sort_by == Info.Manufacturer){
         local s = fe.game_info( Info.Manufacturer, offset )
         return s.slice(0,1)		
      }
      else if (fe.filters[fe.list.filter_index].sort_by == Info.Category){
         	local sout = ""
            local s0 = fe.game_info( Info.Category, offset )
            if (s0 == "") return "" 
            local s = split( s0, "/" )
            if ( s.len() > 1 ) {
               sout = strip(s[0]).toupper()
            }
            else sout = strip(s0).toupper()

            switch (sout){
               case "PLATFORM": return "PLATF"
               case "MULTIPLAY": return "MULTI"
               case "BALL & PADDLE": return "PADDL"
               case "FIGHTER":	return "FIGHT"
               case "DRIVING":	return "DRIVE"
               case "MAZE":	return "MAZE"
               case "MISC.": return "MISC"
               case "CASINO": return "CASINO"
               case "SHOOTER": return "SHOOT"
               case "PUZZLE": return "PUZZL"
               case "SPORTS": return "SPORT"
               case "WHAC-A-MOLE": return "WHAC"
               default: return ""
            }	
         }
      else {
         local s = fe.game_info( Info.Title, offset )
         if (s.find("The ") == 0) s = s.slice(4,s.len())
         local s2 = s.slice(0,1)
         if ("1234567890".find (s2) != null ){
            s2="#"
         }
         return s2
      }
   }
}

local sortlabels = {}
local sortticks = {}

function downkey (order){
   sortlabels [order].set_rgb (255,255,255)
   sortlabels [order].set_bg_rgb (0,0,0)
   sortlabels [order].bg_alpha = 255
}

function upkey (order){
   sortlabels [order].set_rgb (0,0,0)
   sortlabels [order].set_bg_rgb (255,255,255)
   sortlabels [order].bg_alpha = 255
}

local labelorder = []
local labelcounter = {}
local labelstrip = null

function doorderjump(jumpsize){
   local tmp_current = labelorder.find(gamesorter(0))
   local tmp_next = tmp_current + jumpsize

   local tmp_outindex = 0

   if ( (tmp_next >= 0) && (tmp_next < labelorder.len()) ){

      for (local i = 0 ; i < tmp_next ; i++){
         tmp_outindex = tmp_outindex + labelcounter[labelorder[i]]
      }
      fe.list.index = tmp_outindex
   }
}


fe.add_signal_handler( this, "on_signal" )
fe.add_transition_callback( this, "on_transition" )
fe.add_ticks_callback( this, "tick" )	

/// On Transition  



function on_transition( ttype, var0, ttime ) {

   if ((prf.SCROLLERTYPE == "LabelList") && (ttype == Transition.ToNewSelection)){
      local sortl1 = gamesorter(0)
      local sortl2 = gamesorter(var0)

      if (sortl1 != sortl2){
         downkey (sortl1)
         upkey (sortl2)
      }
   }

   if (prf.SCROLLERTYPE != "Scroller"){

      // Clean and update scrollbar labels and tick marks
      if (ttype == Transition.ToNewList){

         // Clean old ticks and labels
         try {
            foreach (label in sortlabels){
               label.visible = false
            }
            foreach (tick in sortticks){
               tick.visible = false
            }
         }
         catch (err){}
         
         // Reinitialize tables
         labelorder = []
         labelcounter = {}

         // Count how many games are in each label
         for (local i = 0 ; i < fe.list.size ; i++){
            local s =  (gamesorter (i-fe.list.index))
            try { labelcounter[s]++ }
            catch (err) { 
               labelcounter[s] <- 1 
               labelorder.push (s)
            }
         }


         local i = 0

         local w0 = flw - 2 * footermargin
         local x0 = footermargin
         local x00 = 0
         local label = {
            w = 100*scalerate,
            h = 40 * scalerate,
            font = 30 * scalerate
         }
         
         local label_obj = null

         if (prf.SCROLLERTYPE == "LabelList"){

            w0 = (flw-2*footermargin)*0.75
            x0 = (flw-w0) * 0.5
            x00 = 0
            label = {
               w = 100*scalerate,
               h = 40 * scalerate,
               font = 30 * scalerate
            }
            labelstrip = data_surface.add_image ("wbox2.png",x0,flh-footer_h*0.5-label.h*0.5,w0,label.h)
            labelstrip.set_rgb (themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
            labelstrip.alpha = 100
            labelstrip.visible = false

            local labelsurf = data_surface.add_surface (w0,label.h)
            labelsurf.set_pos(x0,flh-footer_h*0.5-label.h*0.5)
            labelsurf.add_image("black.png",0,0,w0,label.h)
            foreach (key in labelorder){
               label_obj = labelsurf.add_text(key,x00,0,w0/labelorder.len(),label.h)
               label_obj.charsize = label.font
               label_obj.font = guifont
               label_obj.margin = 0
               label_obj.align = Align.MiddleCentre
               label_obj.set_rgb (255,255,255)
               label_obj.set_bg_rgb (0,0,0)
               label_obj.bg_alpha = 255
               label_obj.alpha = 255
               x00 = x00 + w0/labelorder.len()
               sortlabels[key] <- label_obj 
               downkey (key)
            }
               labelsurf.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
               labelsurf.shader = txtoalpha

            upkey (gamesorter(0))   
         }        

         if (prf.SCROLLERTYPE == "Timeline"){
            labelstrip = data_surface.add_image ("wbox2.png",x0,flh - footer_h * 0.5,w0,label.h)
            labelstrip.set_rgb (themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
            labelstrip.alpha = 100
            labelstrip.visible = false
            foreach (key in labelorder){
               i=1 // REMOVE FOR ALTERNATING LETTERS
               local labelspacer = labelcounter[key]*w0/fe.list.size
               label_obj = data_surface.add_text(key,x0 + labelspacer*0.5 - label.w*0.5, flh - footer_h * 0.5 , label.w,label.h)
               local tick_obj = data_surface.add_image("white.png",x0,flh - footer_h * 0.5 - 0.5*label.h*0.5,1,0.5*label.h+1)
               label_obj.charsize = label.font
               label_obj.font = guifontlite
               label_obj.margin = 0
               label_obj.align = Align.MiddleCentre
               label_obj.set_rgb (themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
               tick_obj.set_rgb (themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
               i++
               label_obj.visible = !( (labelspacer < 0.5*label.h) || ((fe.list.search_rule != "") && (abs(x0-flw*0.5) < 10*scalerate*fe.list.search_rule.len())))
               x0 = x0 + labelspacer
               sortlabels[key] <- label_obj
               sortticks[key] <- tick_obj
            }

            sortticks[labelorder[0]].visible = false

         }
      }
   }
   
   //DEBUG print transition
   if (DEBUG) print ("\nTr:" + transdata[ttype] +" var:" + var0 + "\n")

   //var = 0
   if (ttype == Transition.FromOldSelection) {
      for ( local i = 0; i < tilesTotal ; i++ ) {
                              
         local indexTemp = wrap( i + tilesTableOffset, tilesTotal )

         local horizgame = fe.game_info(Info.Rotation, snapzTable[indexTemp].index_offset )         
         horizgame = ((horizgame == "0") || (horizgame == "180") || (horizgame == "horizontal") || (horizgame == "Horizontal"))

         if (prf.CROPSNAPS){
            if (horizgame){
               snapzTable[indexTemp].subimg_x = snapzTable[indexTemp].texture_width/8.0
               snapzTable[indexTemp].subimg_width = snapzTable[indexTemp].texture_width*3.0/4.0
               }
            else{
               snapzTable[indexTemp].subimg_y = snapzTable[indexTemp].texture_height/8.0
               snapzTable[indexTemp].subimg_height = snapzTable[indexTemp].texture_height*3.0/4.0
            }
         }
         else{
            if (horizgame){
               snapzTable[indexTemp].set_pos (selectorscale*padding,selectorscale*(padding-verticalshift + height/8.0 ),selectorscale*width,selectorscale*height*3.0/4.0)
            }
            else{
               snapzTable[indexTemp].set_pos (selectorscale*(padding+width/8.0),selectorscale*(padding-verticalshift),selectorscale*width*3.0/4.0,selectorscale*height)
            }
         }      
      }
   }

   if ((ttype == Transition.StartLayout) || (ttype == Transition.ToNewList)){
      dat.manufacturer_array[data_stacksize - 1].file_name = manufacturer_pic (0)
      dat.cat_array[data_stacksize - 1].file_name = category_pic (0)
      dat.but_array[data_stacksize - 1].file_name = "button_images/" + fe.game_info(Info.Buttons, 0)+"button.png"
      dat.ply_array[data_stacksize - 1].file_name = "players_images/players_" + fe.game_info(Info.Players,0)+".png"
      dat.ctl_array[data_stacksize - 1].file_name = controller_pic (0)
   }

   // cleanup frosted glass grabs when exiting AM
   if ((ttype == Transition.EndLayout) && (var0 == FromTo.Frontend)){
      for (local ig = 0; ig < frg.numgrabs ; ig++){
         remove(frg.createdgrabs[ig])
      }
   }

   // some fixes for the tags menu
   if (ttype == Transition.ShowOverlay){
      if (var0 == Overlay.Tags) tagsmenu = true
      overlay_show() 
   }

   if (ttype == Transition.HideOverlay){
      overlay_hide()
      // TEST ADD THIS FOR FAVS?      zoompos = 1 
      if (tagsmenu) {
         tagsmenu = false
         tilesTableZoom[newfocusindex] = [0.8,0.8,0.8,0.04,0.0]
      }
   }
   
   // var is updated only if we are going to a new selection
   if (ttype == Transition.ToNewSelection) var = var0
   
   // scroller is always updated		
   scroller.x = footermargin + ((fe.list.index/rows)*rows*1.0/(fe.list.size - 1 ))*(flw - 2.0*footermargin-scrollersize)
   scroller2.x = scroller.x-scrollersize*0.5

   // Cases when tiles will be updated
   if ((ttype == Transition.ToNewList) || (ttype == Transition.ToNewSelection) ) {
      if (DEBUG) print ("TRANSBLOCK 1   - UPDATE TILES \n")
      
      if (prf.THUMBVIDEO) vidpos = 1
               
      if (ttype == Transition.ToNewList) {
         if (DEBUG) print ("TRANSBLOCK 1.2 - RESET VAR CENTERCORRECTION ETC \n")
         var = 0
         tilesTableOffset = 0
         surfacePos = 0.5
         columnoffset = 0
         centercorrection = 0
         centercorrectionshift = centercorrection0
      }

      if (DEBUG) print ("flindex " + fe.list.index + "\n")
      corrector = (rows == 1 ? -1 : -((fe.list.index + var) % rows) )

      colstop = floor((fe.list.index + var)/rows)
      colstart = floor((fe.list.index)/rows)
      columnoffset = (colstop - colstart)
      tilesTableOffset += columnoffset*rows

      local index = - (floor(tilesTotal/2) -1) + corrector 
      //if (ttype == Transition.ToNewList) index = - (floor(tilesTotal/2) -1) - floor(fe.list.index % rows)

      // Determine center position correction when reaching beginning or end of list
      centercorrectionshift = 0	
      centercorrection = 0

      if ((colstop < deltacol) && (var < 0) ) {
         if (colstop == deltacol - 1 ) 
            centercorrectionshift = centercorrection0 + (deltacol - 1)*(width+padding)
         else 
            centercorrectionshift = - (width+padding)
      }
      else if ((colstart < deltacol) && (var > 0)) {
         if (colstart == deltacol - 1 ) 
            centercorrectionshift = - centercorrection0 - (deltacol - 1)* (width+padding)
         else 
            centercorrectionshift = (width+padding)
      }

      if (fe.list.index + var <= deltacol*rows -1){
         centercorrection = centercorrection0 + ((fe.list.index + var)/rows)*(width+padding)
      }
      
      if (columnoffset == 0) centercorrectionshift = 0

      // updates all the tiles, (NOT unless we are changing favourites)
      //if (changedfav == false){

      if (ttype != Transition.ChangedTag) {
         if (DEBUG) print ("TRANSBLOCK 1.3 - CHANGE ALL TILES \n")	

         for ( local i = 0; i < tilesTotal ; i++ ) {
                              
            local indexTemp = wrap( i + tilesTableOffset, tilesTotal )

            if ((ttype == Transition.ToNewList) || (ttype == Transition.StartLayout)){
               loshzTable[indexTemp].index_offset = index
               gradzTable[indexTemp].index_offset = index
            }
            else{
               loshzTable[indexTemp].rawset_index_offset(index )
               gradzTable[indexTemp].rawset_index_offset(index )
            }

            local horizgame = fe.game_info(Info.Rotation, snapzTable[indexTemp].index_offset + var)
            horizgame = ((horizgame == "0") || (horizgame == "180") || (horizgame == "horizontal") || (horizgame == "Horizontal"))

            if (ttype != Transition.ToNewSelection){ 

               if (prf.CROPSNAPS){
                  if (horizgame){
                     snapzTable[indexTemp].subimg_x = snapzTable[indexTemp].texture_width/8.0
                     snapzTable[indexTemp].subimg_width = snapzTable[indexTemp].texture_width*3.0/4.0
                     }
                  else{
                     snapzTable[indexTemp].subimg_y = snapzTable[indexTemp].texture_height/8.0
                     snapzTable[indexTemp].subimg_height = snapzTable[indexTemp].texture_height*3.0/4.0
                  }
               }
               else{
                  if (horizgame){
                     snapzTable[indexTemp].set_pos (selectorscale*padding,selectorscale*(padding-verticalshift + height/8.0 ),selectorscale*width,selectorscale*height*3.0/4.0)
                  }
                  else{
                     snapzTable[indexTemp].set_pos (selectorscale*(padding+width/8.0),selectorscale*(padding-verticalshift),selectorscale*width*3.0/4.0,selectorscale*height)
                  }
               }
            }

            tilesTable[indexTemp].zorder = -2

            favezTable[indexTemp].visible = (fe.game_info(Info.Favourite, snapzTable[indexTemp].index_offset + var) == "1")
            donezTable[indexTemp].visible = ((fe.game_info(Info.Tags, snapzTable[indexTemp].index_offset + var)).find("Completed") != null)
                       
            if (horizgame){
               sh_hzTable[indexTemp].visible = true
               sh_vzTable[indexTemp].visible = false
               if(!prf.CROPSNAPS) nw_mxTable[indexTemp].set_pos (selectorscale*padding,selectorscale*(padding-verticalshift+height*6.0/8.0))
               nw_mxTable[indexTemp].visible = (fe.game_info(Info.PlayedCount, snapzTable[indexTemp].index_offset+var) == "0") 
            }
            else {
               sh_hzTable[indexTemp].visible = false
               sh_vzTable[indexTemp].visible = true
               if(!prf.CROPSNAPS)  nw_mxTable[indexTemp].set_pos (selectorscale*(padding+width/8.0),selectorscale*(padding-verticalshift+height*7.0/8.0))
               nw_mxTable[indexTemp].visible = (fe.game_info(Info.PlayedCount, snapzTable[indexTemp].index_offset+var) == "0") 
            }
            
            tilesTablePosX[indexTemp] = (i/rows) * (width+padding) + carrierT.x + centercorrection + widthpadded*0.5
            tilesTablePosY[indexTemp] = (i%rows) * (height + padding) + carrierT.y + verticalshift + widthpadded*0.5

            tilesTable[indexTemp].visible = (( (fe.list.index + var + index < 0) || (fe.list.index + var + index > fe.list.size-1) ) == false)
            
            // if tranisioning to a new list, reset position and size of all thumbnails, not needed in normal scroll
            if ((ttype == Transition.ToNewList) ) {
               if (DEBUG) print ("R")
               DEBUGPRINTER = true
               //vidszTable[indexTemp].visible = false
               if (prf.THUMBVIDEO) vidszTable[indexTemp].file_name = "transparent.png"
               picsize (tilesTable[indexTemp] , widthpadded, heightpadded)
               tilesTable[indexTemp].zorder = -2
               tilesTableZoom[i] = [0.0,0.0,0.0,0.0,0.0]
               bd_mxTable[i].alpha = 0
               glomxTable[i].alpha = 0
               //glovzTable[indexTemp].visible = glohzTable[indexTemp].visible = false
            }
            
            index++
      }

      if (DEBUG && DEBUGPRINTER) {
         print ("\n")
         DEBUGPRINTER = false
         }
      }
      
      // updates the size and features of the previously selected item and new selected item
      newfocusindex = wrap( floor(tilesTotal/2)-1-corrector + tilesTableOffset, tilesTotal )
      oldfocusindex = wrap( floor(tilesTotal/2)-1-corrector -var + tilesTableOffset, tilesTotal )

      tilesTableZoom[oldfocusindex] = startfade (tilesTableZoom[oldfocusindex],-0.055,1.0)
      tilesTableZoom[newfocusindex] = startfade (tilesTableZoom[newfocusindex],0.035,-5.0)

      tilesTable[oldfocusindex].zorder = -2
      tilesTable[newfocusindex].zorder = -1
      letterobj.zorder = 0

      //vidszTable[oldfocusindex].visible = false
      if (prf.THUMBVIDEO) vidszTable[oldfocusindex].file_name = "transparent.png"
      
      favezTable[newfocusindex].visible = (fe.game_info(Info.Favourite, snapzTable[newfocusindex].index_offset+var) == "1")		
      donezTable[newfocusindex].visible = ((fe.game_info(Info.Tags, snapzTable[newfocusindex].index_offset+var)).find("Completed") != null)
      
      local m = fe.game_info(Info.Rotation, snapzTable[newfocusindex].index_offset+var) 
 
      glomxTable[newfocusindex].visible = true
      bd_mxTable[newfocusindex].visible = true
      nw_mxTable[newfocusindex].visible = (fe.game_info(Info.PlayedCount, snapzTable[newfocusindex].index_offset+var) == "0")

      if ((m == "0") || (m == "180") || (m == "horizontal") || (m == "Horizontal")){
         glomxTable[newfocusindex].shader.set_param ("vertical",0.0)
         if (!prf.CROPSNAPS) {
            nw_mxTable[newfocusindex].set_pos (selectorscale*padding,selectorscale*(padding-verticalshift+height*6.0/8.0))
            bd_mxTable[newfocusindex].set_pos (selectorscale*padding*(1.0-whitemargin),selectorscale*(-verticalshift + height/8.0 + padding*(1.0 - whitemargin)),selectorscale*(width + padding*2.0*whitemargin),selectorscale*(height*(3.0/4.0)+padding*2.0*whitemargin))
         }
      }
      else {
         glomxTable[newfocusindex].shader.set_param ("vertical",1.0)
         if (!prf.CROPSNAPS) {
            nw_mxTable[newfocusindex].set_pos (selectorscale*(padding+width/8.0),selectorscale*(padding-verticalshift+height*7.0/8.0))
            bd_mxTable[newfocusindex].set_pos (selectorscale*(width/8.0 + padding*(1.0 - whitemargin)), selectorscale*(-verticalshift + padding*(1.0 - whitemargin)),selectorscale*(width*(3.0/4.0)+padding*2.0*whitemargin),selectorscale*(height + padding*2.0*whitemargin))
         }
      }

      // trigger squaring of thumbs
      squarizer = true

   }
   
   // if the transition is to a new selection initialize crossfade, scrolling and surfacepos
   if( (ttype == Transition.ToNewSelection) ){
      
      if (DEBUG) print ("TRANSBLOCK 2.0 - TRANSITION TO NEW SELECTION ONLY \n")
      //snapbg1.rawset_index_offset (-var)
      //if (prf.LAYERSNAP) bgvid1.rawset_index_offset (-var)

      local l1 = gameletter (0)
      local l2 = gameletter(var)
      
      if (l1 != l2){
         fadeletter = 1
      }

      for (local i = 0; i < bg_stacksize-1;i++){
         bgs.bgpicarray[i].swap(bgs.bgpicarray[i+1])
         bgs.alphapos[i] = bgs.alphapos[i+1]
      }

      for (local i = 0; i < data_stacksize - 2;i++){
         dat.var_array[i] = - var + dat.var_array[i+1]
      }
      dat.var_array [data_stacksize - 1] = 0
      dat.var_array [data_stacksize - 2] = - var 

      for (local i=0 ; i< data_stacksize -1 ; i++){
      //			dat.manufacturer_array[i].rawset_index_offset(dat.var_array[i])
      //			dat.cat_array[i].rawset_index_offset(dat.var_array[i])

      dat.manufacturer_array[i].swap (dat.manufacturer_array[i+1])
      dat.cat_array[i].swap (dat.cat_array[i+1])
      dat.but_array[i].swap (dat.but_array[i+1])
      dat.ply_array[i].swap (dat.ply_array[i+1])
      dat.ctl_array[i].swap (dat.ctl_array[i+1])

      dat.mainctg_array[i].index_offset = dat.var_array[i]
      dat.gamename_array[i].index_offset = dat.var_array[i]
      dat.gamesubname_array[i].index_offset = dat.var_array[i]
      dat.gameyear_array[i].index_offset = dat.var_array[i]
      
      if (i != data_stacksize -2 )
         dat.alphapos[i] = dat.alphapos[i+1]
      else
         dat.alphapos[i] = 1.0 - dat.alphapos[i+1]
      }

      dat.manufacturer_array[data_stacksize - 1].file_name = manufacturer_pic (var)
      dat.cat_array[data_stacksize - 1].file_name = category_pic (var)
      dat.but_array[data_stacksize - 1].file_name = "button_images/"+fe.game_info(Info.Buttons, var)+"button.png"
      dat.ply_array[data_stacksize - 1].file_name = "players_images/players_" + fe.game_info (Info.Players , var)+".png"
      dat.ctl_array[data_stacksize - 1].file_name = controller_pic (var)
      dat.alphapos [data_stacksize - 1] = 1

      bgs.alphapos [bg_stacksize - 1]= 255
      
      surfacePos += (columnoffset * (width + padding) ) - centercorrectionshift
      
   }

   return false
}

/// On Tick  
function tick( tick_time ) {

   // Attract mode management
   if (prf.AMENABLE) {

      if (attract.start){
         // block theme videos and set snap audio
         if (prf.LAYERVIDEO) bgs.bgvidarray[bg_stacksize - 1].video_playing = false
         if (prf.THUMBVIDEO) vidszTable[newfocusindex].video_playing = false
         if (!attract.sound) attract_snap.video_flags = Vid.NoAudio

         if(prf.AMTUNE != "") snd.attracttune.playing=true

         attract.start = false
         attract.rolltext = true
         attract.gametimer = true
         //attract.updatesnap = true
         attractupdatesnap()
         attract.timer = tick_time
      }

      if (attract.rolltext){
         attract_text2.alpha = 255*(0.5+0.5*cos(tick_time/500.0))
         attract_text.alpha =  attract.textshadow * attract_text2.alpha / 255
      }

      if (attract.gametimer){
         if ((tick_time - attract.timer) > attract.game_interval){
            flowT.gametoblack = startfade (flowT.gametoblack,0.1,0.0)
         }         
      }

      if (attract.starttimer){
         if ((tick_time - attract.timer) > attract.attract_interval){
            attractkick()
         }
      }
   }

   // Apply square screen cropping for background artwork
   if (squarizer){
      squarizer = false
      squarebg()
   }

   if ((rightcount != 0) && (fe.get_input_state("right")==false)){
      rightcount = 0
   }
   
   if ((leftcount != 0) && (fe.get_input_state("left")==false)){
      leftcount = 0
   }
   
   // crossfade of the blurred background
   for (local i = 0 ; i < bg_stacksize ; i++){
      if (bgs.alphapos[i] !=0){
         if ((bgs.alphapos[i] < 1) && (bgs.alphapos[i] > -1) ) bgs.alphapos[i] = 0
         bgs.alphapos[i] = bgs.alphapos[i] * spdT.bgfadespeed
         bgs.bgpicarray[i].alpha = 255-bgs.alphapos[i]
         if (prf.LAYERSNAP) bgs.bgvidarray[i].alpha = 255-bgs.alphapos[i] 
      }
   }

   // fading of the initial letter of the name
   if (fadeletter != 0){
      if(fadeletter < 0.01) fadeletter = 0
      fadeletter = fadeletter * spdT.letterspeed
      letterobj.alpha = 255*(1-4.0*pow((0.5-fadeletter),2))
   }
   
   // Manage tiles zoom and unzoom
   for(local i = 0 ; i < tilesTotal ; i++){
      if (checkfade(tilesTableZoom[i])){
         tilesTableZoom[i] = fadeupdate(tilesTableZoom[i])
         local zoomtemp = tilesTableZoom[i]
         if ((zoomtemp[1] + zoomtemp[3] < 0) || (zoomtemp[1] + zoomtemp[3] > 1)){
            tilesTableZoom[i] = (zoomtemp[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
            zoomtemp = tilesTableZoom[i]
         }

         // hide glow image and border image when zero is reached
         if ((zoomtemp[1] == 0)){
            glomxTable[i].visible = false
            bd_mxTable[i].visible = false
         }

         // update size and glow alpha
         picsize(tilesTable[i], widthpadded + (selectorwidth-widthpadded)*(zoomtemp[1]), widthpadded + (selectorwidth-widthpadded)*(zoomtemp[1]))
         if (zoomtemp[3] < 0){ 
            glomxTable[i].alpha = 255*pow(zoomtemp[1],5)
            bd_mxTable[i].alpha = 240*pow(zoomtemp[1],5)
         }
         else{
            glomxTable[i].alpha = 255*(zoomtemp[1])
            bd_mxTable[i].alpha = 240*(zoomtemp[1])
         }
      }
   }

   // crossfade of game data
   for (local i = 0 ; i < data_stacksize ; i++){
      if (dat.alphapos[i] != 0 ){
         if ((dat.alphapos[i] <0.01) && (dat.alphapos[i] > -0.01)) dat.alphapos[i] = 0

         if (i != data_stacksize -1){
            dat.alphapos[i] = dat.alphapos[i] * spdT.dataspeedout
            dat.ply_array[i].alpha = dat.ctl_array[i].alpha = dat.but_array[i].alpha = dat.cat_array[i].alpha = dat.mainctg_array[i].alpha = dat.manufacturer_array[i].alpha = dat.gamename_array[i].alpha = dat.gamesubname_array[i].alpha = dat.gameyear_array[i].alpha = 255 * (dat.alphapos[i])*1.0
         }
         else {
            dat.alphapos[data_stacksize -1] = dat.alphapos[data_stacksize - 1] * spdT.dataspeedin
            dat.ply_array[i].alpha = dat.ctl_array[i].alpha = dat.but_array[data_stacksize - 1].alpha = dat.cat_array[data_stacksize - 1].alpha = dat.mainctg_array[data_stacksize - 1].alpha = dat.manufacturer_array[data_stacksize - 1].alpha = dat.gamename_array[data_stacksize - 1].alpha = dat.gamesubname_array[data_stacksize - 1].alpha = dat.gameyear_array[data_stacksize - 1].alpha = 255 * (1.0 - dat.alphapos[data_stacksize - 1])*1.0
         }
      }
   }

   // tiles scrolling
   if ((surfacePos != 0)) {	
     /* if (zoompos == 1){
         // Useful check to update "Completed" tag when changing tags
         local m = fe.game_info(Info.Tags, snapzTable[newfocusindex].index_offset)
         donezTable[newfocusindex].visible = (m.find("Completed") != null)
      }*/
      
      if ((surfacePos < 0.1) && (surfacePos > -0.1)) surfacePos = 0      
      surfacePos = surfacePos * spdT.scrollspeed

      if (surfacePos > surfacePosOffset) surfacePos = surfacePosOffset
      if (surfacePos < -surfacePosOffset) surfacePos = -surfacePosOffset
      
      // repositioning of tiles		
      for ( local i = 0; i < tilesTotal; i++ ) {
         tilesTable[i].x = surfacePos - surfacePosOffset + tilesTablePosX[i]
         tilesTable[i].y = tilesTablePosY[i]
      }

      globalposnew = tilesTable[newfocusindex].x 

   }
   
   // crossfade of video snaps, tailored to skip initial fade in
   if (( vidpos != 0 )) {
      
      vidpos = vidpos - 0.01
      if (vidpos < 0.01) vidpos = 0
      // newfocusindex = wrap( tilesTotal/2-1-corrector + tilesTableOffset, tilesTotal )

      if ((vidpos < delayvid) && (vidpos > delayvid - 0.01)){
         //vidszTable[newfocusindex].visible = true
         if (prf.THUMBVIDEO) vidszTable[newfocusindex].file_name = fe.get_art("snap")
         if (prf.AMENABLE) {
            if (attract.rolltext) vidszTable[newfocusindex].video_playing = false
         }
         vidszTable[newfocusindex].alpha = vid2zTable[newfocusindex].alpha = 0		
         if (prf.CROPSNAPS){
            if (snapzTable[newfocusindex].texture_width >= snapzTable[newfocusindex].texture_height){
               vidszTable[newfocusindex].subimg_x = vidszTable[newfocusindex].texture_width/8.0
               vidszTable[newfocusindex].subimg_width = vidszTable[newfocusindex].texture_width*3/4.0
               vid2zTable[newfocusindex].subimg_x = vid2zTable[newfocusindex].texture_width/8.0
               vid2zTable[newfocusindex].subimg_width = vid2zTable[newfocusindex].texture_width*3/4.0
            }
            else{
               vidszTable[newfocusindex].subimg_y = vidszTable[newfocusindex].texture_height/8.0
               vidszTable[newfocusindex].subimg_height = vidszTable[newfocusindex].texture_height*3/4.0	
               vid2zTable[newfocusindex].subimg_y = vid2zTable[newfocusindex].texture_height/8.0
               vid2zTable[newfocusindex].subimg_height = vid2zTable[newfocusindex].texture_height*3/4.0
            }
         }

      }
      
      if (vidpos <= fadevid)
      vidszTable[newfocusindex].alpha = vid2zTable[newfocusindex].alpha = 255.0*(1-vidpos*(1/fadevid))
      else
      vidszTable[newfocusindex].alpha = vid2zTable[newfocusindex].alpha = 0
   }
   
   // screen grabbing for frosted surface

	if (frg.grabdither != 0) {
		frg.grabdither --
		frost_surface.x = frg.grabdither
      frost_top.file_name = "transparent.png"
	}

	if (frg.grabticker != 0)
	{
		frg.grabticker --
		if (frg.grabticker == 0){
			rename (frg.firstpath,frg.grabpath)
			frost_pic.file_name = frg.grabpath
         // TEST 
         frost_top.alpha = 255
         flowT.frostfade = [1.0,1.0,1.0,0.0,0.0]
         frost_top.file_name = frg.grabpath
         flowT.frostfade = startfade (flowT.frostfade, -0.1,0.0)
			if (rotate90){
				
			}
		frg.immediatesignal = true
		fe.signal(frg.grabsignal)
		}
	}

   // context menu fade in fade out

	if ((overmenu.visible) && (flowT.overmenu[3] >= 0) && (surfacePos != 0)) {
		overmenu.x = globalposnew  - overmenuwidth*0.5 
	}


   if (checkfade (flowT.frostfade)){
      flowT.frostfade = fadeupdate(flowT.frostfade)
      if ((flowT.frostfade[1] + flowT.frostfade[3] < 0) || (flowT.frostfade[1] + flowT.frostfade[3] > 1)){
         flowT.frostfade = (flowT.frostfade[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
      }
      frost_top.alpha = 255  * (flowT.frostfade[1])
   }


   if (checkfade (flowT.historyblack)){
      flowT.historyblack = fadeupdate(flowT.historyblack)

      if ((flowT.historyblack[1] + flowT.historyblack[3] < 0) || (flowT.historyblack[1] + flowT.historyblack[3] > 1)){
         flowT.historyblack = (flowT.historyblack[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
         if (flowT.historyblack[1] == 1) {
            // history_updatesnap()
            flowT.historyblack = startfade (flowT.historyblack,-flowT.historyscroll[3]*2.0,0.0)
         }       
      }

      hist_screensurf.set_rgb (255  * (1.0 - flowT.historyblack[1]),255  * (1.0 - flowT.historyblack[1]),255  * (1.0 - flowT.historyblack[1]))
      hist_glow_pic.set_rgb (255  * (1.0 - flowT.historyblack[1]),255  * (1.0 - flowT.historyblack[1]),255  * (1.0 - flowT.historyblack[1]))      
      hist_glow_pic.alpha =  hist_screensurf.alpha = 255  * (1.0 - flowT.historyblack[1])

   }

   if (checkfade (flowT.historyscroll)){
      flowT.historyscroll = fadeupdate(flowT.historyscroll)

      if ((flowT.historyscroll[1] + flowT.historyscroll[3] < 0) || (flowT.historyscroll[1] + flowT.historyscroll[3] > 1)){
         flowT.historyscroll = (flowT.historyscroll[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
         if (flowT.historyscroll[1] == 1) {
            history_updatesnap()
            scrollreset = false
            flowT.historyscroll = [0.0,0.0,0.0,0.0751,0.0]
         } 
      }

      if ((flowT.historyscroll[1] < 0.5) && (flowT.historyscroll[1] > 0.5 - flowT.historyscroll[3]) && (!scrollreset)) flowT.historyscroll = [0.5,0.5,0.5,0.0,0.0]

      if (!vertical){
         hist_screensurf.y = hist_screenT.y + historypadding - hist_direction * 1.50 * flh * (flowT.historyscroll[1] - 0.5)
         shadowsurf2.y =  histglow.y - shadow_radius  - hist_direction * 1.50 * flh * (flowT.historyscroll[1] - 0.5)
      }
      else
      {
         hist_screensurf.x = hist_screenT.x + historypadding - hist_direction * 1.50 * flw * (flowT.historyscroll[1] - 0.5)
         shadowsurf2.x =  histglow.x - shadow_radius - hist_direction * 1.50 * flw * (flowT.historyscroll[1] - 0.5)  
      }
   }


   if (checkfade (flowT.historydata)){
      flowT.historydata = fadeupdate(flowT.historydata)

      if ((flowT.historydata[1] + flowT.historydata[3] < 0) || (flowT.historydata[1] + flowT.historydata[3] > 1)){
         flowT.historydata = (flowT.historydata[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
         if (flowT.historydata[1] == 1) {
            history_updatetext()
            flowT.historydata = startfade (flowT.historydata,-0.101,3.0)
         }    
      }

      hist_text.alpha = 255  * (1.0 - flowT.historydata[1])

      if (prf.HISTORYPANEL) {
         hist_title.alpha = hist_titleT.transparency  * (1.0 - flowT.historydata[1])
         hist_title_top.alpha = 255  * (1.0 - flowT.historydata[1])
      }
      else {
         hist_title.alpha = 255  * (1.0 - flowT.historydata[1])
      }

   }


   if (checkfade(flowT.overmenu)){
      flowT.overmenu = fadeupdate(flowT.overmenu)

      if ((flowT.overmenu[1] + flowT.overmenu[3] < 0) || (flowT.overmenu[1] + flowT.overmenu[3] > 1)){
         flowT.overmenu = (flowT.overmenu[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
         if (flowT.overmenu[1] == 0) {
            overmenu.visible = false
         }
      }

      overmenu.alpha = 255  * flowT.overmenu[1]
   }

   // splash logo fade in fade out
   if (checkfade(flowT.logo)){
      flowT.logo = fadeupdate(flowT.logo)

      if ((flowT.logo[1] + flowT.logo[3] < 0) || (flowT.logo[1] + flowT.logo[3] > 1)){
         flowT.logo = (flowT.logo[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
      }

      aflogo_surface.alpha = 255  * flowT.logo[1]
   }


   // data surface fade in and fade out
   if (checkfade(flowT.data)){
      flowT.data = fadeupdate(flowT.data)

      if ((flowT.data[1] + flowT.data[3] < 0) || (flowT.data[1] + flowT.data[3] > 1)){
         flowT.data = (flowT.data[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
      }

      data_surface.alpha = 255  * flowT.data[1]
	   data_surface_sh.alpha = themeT.themeshadow * flowT.data[1]
   }

   // foreground surface fade in and fade out
   if (checkfade(flowT.fg)){
      flowT.fg = fadeupdate(flowT.fg)

      if ((flowT.fg[1] + flowT.fg[3] < 0) || (flowT.fg[1] + flowT.fg[3] > 1)){
         flowT.fg = (flowT.fg[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
      }
      fg_surface.alpha = 255  * flowT.fg[1]
   }

   // attract mode surface fade
   if (checkfade(flowT.attract)){
      flowT.attract = fadeupdate(flowT.attract)

      if ((flowT.attract[1] + flowT.attract[3] < 0) || (flowT.attract[1] + flowT.attract[3] > 1)){
         flowT.attract = (flowT.attract[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
         
         if (flowT.attract[1] == 0) {
            attract_snap.file_name = "transparent.png"
            attract_snap.shader = noshader
            attract_surface.visible = false
            attract_text.visible = attract_text2.visible = false
            attract.starttimer = true
            if(prf.AMTUNE != "") snd.attracttune.playing=false

         }
      }
      attract_surface.alpha = attract_text2.alpha = 255  * flowT.attract[1]
      attract_text.alpha = attract.textshadow * flowT.attract[1]
   }

   // Fade to black games in attract mode
   if (checkfade(flowT.gametoblack)){
      
      flowT.gametoblack = fadeupdate(flowT.gametoblack)

      if ((flowT.gametoblack[1] + flowT.gametoblack[3] < 0) || (flowT.gametoblack[1] + flowT.gametoblack[3] > 1)){
         flowT.gametoblack = (flowT.gametoblack[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
         if (flowT.gametoblack[1] == 1) {

            attract_snap.alpha = 255
            attractupdatesnap()
            attract.timer = tick_time
            flowT.gametoblack = startfade (flowT.gametoblack,-0.02,0.0)
         }
      }
      attract_black.bg_alpha = 255 * flowT.gametoblack[1]
   }

   // Fade whole layout from black
   if (checkfade(flowT.blacker)){
      flowT.blacker = fadeupdate(flowT.blacker)

      if ((flowT.blacker[1] + flowT.blacker[3] < 0) || (flowT.blacker[1] + flowT.blacker[3] > 1)){
         flowT.blacker = (flowT.blacker[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
         if (flowT.blacker[1] == 0) {
            layoutblacker.visible = false
            if ((!prf.AMENABLE) || (!prf.AMSTART)) layoutfadein ()

         }
      }
      layoutblacker.alpha = 255 * flowT.blacker[1]
   }

   // history text fade
   if (checkfade(flowT.histtext)){
      flowT.histtext = fadeupdate(flowT.histtext)

      if ((flowT.histtext[1] + flowT.histtext[3] < 0) || (flowT.histtext[1] + flowT.histtext[3] > 1)){
         flowT.histtext = (flowT.histtext[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])  
      }

      hist_text.y = hist_textT.h * (1.0 - flowT.histtext[1])
   }

   // history page fade in fade out
   if (checkfade(flowT.history)){
      flowT.history = fadeupdate(flowT.history)

      if ((flowT.history[1] + flowT.history[3] < 0) || (flowT.history[1] + flowT.history[3] > 1)){
         flowT.history = (flowT.history[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
         if (flowT.history[1] == 0) {
            hist_title.file_name = "transparent.png"
            hist_screen.file_name = "transparent.png"
            hist_screen.shader = noshader
            shadowsurf1.shader = noshader
            shadowsurf2.shader = noshader
            hist_text_surf.shader = noshader
            history_surface.visible = false
         }
      }

      history_surface.alpha = 255  * flowT.history[1]
      // history_surface.y = flh * (1.0-flowT.history[1])
      // hist_text.y = hist_textT.h * (1.0 - flowT.history[1])
   }
   
}


/// On Signal  
function on_signal( sig ){

   /*
   if (sig == "custom1"){
      fe.list.search_rule = "Title contains abal"
   }
   
   if (sig == "custom2"){
      fe.list.search_rule = ""
   }
   */

  

   if (DEBUG) print ("\n Si:" + sig )

   //if (sig == "exit") snd.wooshsound.playing = true
   
   // frosted glass effect signal response
   if (prf.FROSTEDGLASS){

      if (sig == "exit"){
         if (frg.immediatesignal){
            frg.immediatesignal = false
            return false
         }
         else{
            getsnap("exit")
            return true
         }
      }

      if (sig == "filters_menu"){
         if (frg.immediatesignal){
            frg.immediatesignal = false
            return false
         }
         else{
            getsnap("filters_menu")
            return true
         }
      }

      if (sig == "add_favourite"){
         if (frg.immediatesignal){
            frg.immediatesignal = false
            return false
         }
         else{
            getsnap("add_favourite")
            return true
         }
      }

      if (sig == "add_tags"){
         if (frg.immediatesignal){
            frg.immediatesignal = false
            return false
         }
         else{
            getsnap("add_tags")
            return true
         }
      }
   }

   // rotation controls signal response
   if(sig == "toggle_rotate_right"){
      if (fe.layout.toggle_rotation == RotateScreen.None)
      {
         fe.layout.toggle_rotation = RotateScreen.Right
         fe.signal ("reload")
      }
      else{
         fe.layout.toggle_rotation = RotateScreen.None
         fe.signal ("reload")
      }
      return true
   }

   if(sig == "toggle_rotate_left"){
      if (fe.layout.toggle_rotation == RotateScreen.None)
      {
         fe.layout.toggle_rotation = RotateScreen.Left
         fe.signal ("reload")
      }
      else{
         fe.layout.toggle_rotation = RotateScreen.None
         fe.signal ("reload")
      }
      return true
   }



   // Key response when attract mode is enabled (running or not)
   if (prf.AMENABLE){
      // Resets attract timer so when attract is not running the wait time is reset
      attract.timer = fe.layout.time
      
      if (attract.rolltext){
         // If attract is running stops attract unless we are taking screenshots

         if (sig == "screenshot") return false

         flowT.attract = [1.0,1.0,1.0,-0.09,1.0]
         attract.start = false
         attract.rolltext = false
         attract.gametimer = false

         fe.list.index ++
         fe.list.index--
         layoutfadein()
 
         return true
      }

   }


   // context menu signal response
   if (overmenu_visible())
   {
      if (DEBUG) print (" OVERMENU \n")

      if (sig == "up"){
         
         if (prf.FROSTEDGLASS){
            if (frg.immediatesignal){
            if(prf.THEMEAUDIO) snd.wooshsound.playing=true
               frg.immediatesignal = false
            }
            else{
               getsnap("up")
               return true
            }
         }

         overmenu_hide(true)
         //snd.wooshsound.playing=true
         searchtext =""
         local switcharray = [
            "Year",
            "Decade",
            "Manufacturer",
            "Main Category",
            "Sub Category",
            "RESET"
         ]
         local result = fe.overlay.list_dialog(switcharray,"More of the same...")
         
         if(result==5){
            //fe.list.index += corrector + rows 
            fe.list.search_rule =""
            searchdata.msg = ""
            if (backindex != -1){
               fe.list.index = backindex
               //corrector = backcorrector
               backindex = -1
            }					 
         }
         
         if (result == 0) {
            searchtext = "Year contains "+ fe.game_info(Info.Year)
         }

         if (result == 1) {
            searchtext = "Year contains "+ fe.game_info(Info.Year).slice(0,3)
         }

         if (result == 2) {
            searchtext = "Manufacturer contains "+fe.game_info(Info.Manufacturer)
         }

         if (result == 3) {
            searchtext = (fe.game_info(Info.Category))
            local s = split( searchtext, "/" )
            searchtext = "Category contains "+s[0]
         }

         if (result == 4) {	
            searchtext = "Category contains "+fe.game_info(Info.Category)		
         }
         // GOOD!
         if ((result !=5) && (result != -1)) {
            if (backindex == -1) {
               backindex = fe.list.index
               //backcorrector = corrector
            }
            //fe.list.index += corrector + tilesTotal 
            fe.list.index ++
            fe.list.search_rule = searchtext
            //fe.list.index = 0
            corrector = (rows == 1 ? -1 : 0)
            searchdata.msg = searchtext
         }
         return true
      }

      else if (sig == "down") {
         overmenu_hide(false)
         //try {
            history_show(true)
         //} catch ( err ) { print( "History Error\n" ); }

         return true
      }

      else if (sig == "left") {
         // add tags
         overmenu_hide(true)
            if(prf.THEMEAUDIO) snd.wooshsound.playing=true
         fe.signal ("add_tags")
         return true
      }

      else if (sig == "right") {
         // add current game to favorites
         overmenu_hide(true)
         //changedfav = true
            if(prf.THEMEAUDIO) snd.wooshsound.playing=true
         fe.signal("add_favourite")
         return true
      }

      else if (sig == "back") {
         overmenu_hide(false)
         return true
      }

      else if (sig == "select") {
         overmenu_hide(true)
         return false
      }
      else if ((sig == prf.OVERMENUBUTTON) && (prf.OVERMENUBUTTON != "select")) {
         overmenu_hide(false)
         return true
      }
      
      return false 
   }
   
   // history page signal response
   else if (history_visible())
   {
      if (DEBUG) print (" HISTORY \n")

      if (sig == "up") {
         on_scroll_up()
         return true
      }

      else if (sig == "down") {
         on_scroll_down()
         return true
      }

      else if ((sig == "left")) {
         fe.list.index--
         history_changegame(-1)
         //history_show(false)
         return true
      }

      else if ((sig == "right") ) {
         fe.list.index++
         history_changegame(1)
         //history_show(false)
         return true
      }

      else if ( (sig == "random_game") || (sig == "next_favourite")  ||(sig == "next_letter")  || (sig == "next_game") || (sig == "next_page")){
         
         if (sig == "random_game") fe.list.index = fe.list.size*rand()/RAND_MAX
         history_changegame(1)
         //history_show(false)
         return true         
      }

      else if ((sig == "prev_favourite") || (sig == "prev_letter")  || (sig =="prev_game") || (sig =="prev_page") ){
      
         history_changegame(-1)

         //history_show(false)
         return true         
      }

      else if (sig == "back") {
         history_exit()
         return true
      }

      return false 
   }

   // search page signal response
   else if (search_visible())
   {
      if (DEBUG) print (" SEARCH \n")

      if ( sig == "up" ) {
         search_select_relative( 0, -1 )
         while (key_rows[key_selected[1]][key_selected[0]].tochar()=="_") search_select_relative( 0, -1 )
      }

      else if ( sig == "down" ) {
         search_select_relative( 0, 1 )
         while (key_rows[key_selected[1]][key_selected[0]].tochar()=="_") search_select_relative( 0, 1 )
      }

      else if ( sig == "left" ) {
         search_select_relative( -1, 0 )
         while (key_rows[key_selected[1]][key_selected[0]].tochar()=="_") search_select_relative( -1, 0 )
      }

      else if ( sig == "right" ) {
         search_select_relative( 1, 0 )
         while (key_rows[key_selected[1]][key_selected[0]].tochar()=="_") search_select_relative( 1, 0 )
      }

      else if ( sig == "select" ) search_type( key_rows[key_selected[1]][key_selected[0]].tochar() )
      //else if ( sig == "back" ) search_type("<")
      //else if ( sig == "exit" ) search_toggle()
      else if ( sig == "back" ) search_toggle()
   
      else if (sig == "screenshot"){
         return false
      }

      return true
   }
   
   // normal signal response
   else {

         // next and previous game or page signal response
      if(sig == "next_game"){
         fe.list.index ++
         return true
      }
      if(sig == "prev_game"){
         fe.list.index --
         return true
      }
      if(sig == "prev_page"){
         fe.list.index = fe.list.index - rows*(cols - 2)
         return true
      }
      if(sig == "next_page"){
         fe.list.index = fe.list.index + rows*(cols -2)
         return true
      }

      if (sig == "random_game"){
         fe.list.index = fe.list.size*rand()/RAND_MAX
         return true
      }  

      if (DEBUG) print (" NORMAL \n")
      switch ( sig ){			

         case prf.OVERMENUBUTTON:
         overmenu_show()
         return true

         case "left":

         if (sortjump){
            doorderjump (-1)
            return true
         }

         if (fe.list.index > scrollstep - 1) {
            if (leftcount == 0) {
               fe.list.index -= scrollstep
               if(prf.THEMEAUDIO) snd.ticksound.playing=true
               leftcount ++
            }
            else {
               leftcount ++
               if (leftcount == movecount)	leftcount = 0			
            }
         }
         else tilesTableZoom[newfocusindex] = [0.8,0.8,0.8,0.04,0.0]
         return true
         
         case "right":
         if (sortjump){
            doorderjump (1)
            return true
         }
         if ((fe.list.index < fe.list.size - scrollstep)){
            if (rightcount == 0) {
               fe.list.index += scrollstep
               if(prf.THEMEAUDIO) snd.ticksound.playing=true
               rightcount ++
            }
            else {
               rightcount ++
               if (rightcount == movecount)	rightcount = 0			
            }
         }
         else tilesTableZoom[newfocusindex] = [0.8,0.8,0.8,0.04,0.0]
         return true
         
         case "up":
         if ((fe.list.index % rows > 0) && (scrolljump == false) && (sortjump == false)) {
            fe.list.index --
            if(prf.THEMEAUDIO) snd.ticksound.playing=true
         }
         else if (scrolljump == true){
            if(prf.THEMEAUDIO) snd.wooshsound.playing=true
            scrolljump = false
            scrollstep = rows
            scroller2.visible = scrollineglow.visible = false
         }
         else if (sortjump == true){
            if(prf.THEMEAUDIO) snd.wooshsound.playing=true
            sortjump = false
            labelstrip.visible = false
            foreach (key in sortlabels) {
               key.style = Style.Regular
               key.charsize = 30 * scalerate

            }
            if (prf.SCROLLERTYPE != "LabelList") {
               scrolljump = true
               scrollstep = rows*(cols-2)
               scroller2.visible = scrollineglow.visible = true   
            }         
         }

         else {
            if (prf.FROSTEDGLASS){
               if (frg.immediatesignal){
               //snd.wooshsound.playing=true	
               frg.immediatesignal = false
               }
               else{
               getsnap("up")
               return true
               }
            }
            else {
               if(prf.THEMEAUDIO) snd.wooshsound.playing=true
                  }

            local switcharray1 = [
               "Filters",
               "Search for...",
               "Layout options",
               "Attract mode"
            ]

            local result1 = fe.overlay.list_dialog(switcharray1,"Utility Menu")

            if (result1 == 0){
               //	snd.wooshsound.playing=true
               frg.immediatesignal = true
               fe.signal("filters_menu")
            if(prf.THEMEAUDIO) snd.wooshsound.playing=true
            }

            if ((result1 == 3) && (prf.AMENABLE)){
               attractkick()
            }

            if (result1 == 2){
               //	snd.wooshsound.playing=true
            fe.signal("layout_options")
            if(prf.THEMEAUDIO) snd.wooshsound.playing=true
            }	

            if (result1 == 1){
            if(prf.THEMEAUDIO) snd.wooshsound.playing=true

            searchtext =""
            local switcharray2 = [
               "Title",
               "Manufacturer",
               "Year",
               "Category",
               "RESET"
            ]
            local result = fe.overlay.list_dialog(switcharray2,"Search for...")
            
            if(result==4){
               //fe.list.index += corrector + rows 
               fe.list.search_rule =""
               searchdata.msg = ""
               if (backindex != -1){
                  fe.list.index = backindex
                  //corrector = backcorrector
                  backindex = -1
               }
               //return
            }

            if ((result != 4)&&(result !=-1)){
               if (prf.KEYBOARD) 
                  searchtext = fe.overlay.edit_dialog("Search "+switcharray2[result]+": ",searchtext)
               else
                  search_base_rule = switcharray2[result]
               
               if (backindex == -1){
                  backindex = fe.list.index
                  //backcorrector = corrector
               }
               
               if (prf.KEYBOARD)
               {
                  fe.list.index ++
                  fe.list.search_rule = switcharray2[result]+" contains "+ recalculate(searchtext)
                  fe.list.index = 0
                  corrector = (rows == 1 ? -1 : 0)
                  if(fe.list.search_rule == ""){
                     searchdata.msg = ""
                     if (backindex != -1){
                        fe.list.index = backindex
                        //corrector = backcorrector
                        backindex = -1
                     }
                  }
                  else
                  searchdata.msg = fe.list.search_rule
               }
               else{
                  search_toggle()
               }
               
               return true
               
            }
            return true
            }
         }
         return true
         
         case "down":
         if  ((scrolljump == false) && (sortjump == false) &&  ((fe.list.index % rows < rows -1) && ( ! ( (fe.list.index / rows == fe.list.size / rows)&&(fe.list.index%rows + 1 > (fe.list.size -1)%rows) ))) ){
            if ((corrector == 0) && (fe.list.index == fe.list.size-1)) return true
            fe.list.index ++
            if(prf.THEMEAUDIO) snd.ticksound.playing=true
         }

         // if you go down and label list is not active, activate scrolljump
         else if ((scrolljump == false) && (sortjump == false) && (prf.SCROLLERTYPE != "LabelList")){
            if(prf.THEMEAUDIO) snd.wooshsound.playing=true
            scrolljump = true
            scrollstep = rows*(cols-2)
            scroller2.visible = scrollineglow.visible = true	
            sortjump = false
         }
         
         // if scrolljump is enabled and we are not in scrollbar mode, or if we are in labellist mode, activate sortjump
         else if (((scrolljump == true) && (sortjump == false) && (prf.SCROLLERTYPE != "Scrollbar")) || ((prf.SCROLLERTYPE == "LabelList") && (sortjump == false))){
            if(prf.THEMEAUDIO) snd.wooshsound.playing=true
            scrolljump = false
            scroller2.visible = scrollineglow.visible = false
            sortjump = true
            labelstrip.visible = true
            foreach (key in sortlabels) {
               key.style = Style.Bold
               key.charsize = 38 * scalerate
            }

         }

         return true

         // All other cases
         default:
            if(prf.THEMEAUDIO) snd.wooshsound.playing=true
         
      }// END OF SWITCH SIGNAL LOOP 
   }// CLOSE ELSE GROUP
   return false
}
