function file_exist(fullpathfilename){
	try {file(fullpathfilename, "r" );return true;}catch(e){return false;}
}

local controllertable = {
   "joystick (8-way)" : "controller_images/control_joystick_8way.png",
   "joystick (8-way),joystick (8-way)" : "controller_images/control_joystick_8way.png",
   "joystick (8-way),joystick (8-way),joystick (8-way)" : "controller_images/control_joystick_8way.png",
   "joystick (8-way),joystick (8-way),joystick (8-way),joystick (8-way)" : "controller_images/control_joystick_8way.png",

   "joystick (8-way),dial" : "controller_images/control_joystick_8way.png",
   "joystick (8-way),dial,joystick (8-way),dial" : "controller_images/control_joystick_8way.png",
   "joystick (8-way),dial,joystick (8-way),dial,joystick (8-way),dial" : "controller_images/control_joystick_8way.png",
   "joystick (8-way),dial,joystick (8-way),dial,joystick (8-way),joystick (8-way)" : "controller_images/control_joystick_8way.png",

   "joystick (8-way),joystick (analog)" : "controller_images/control_joystick_8analog.png",
   "joystick (8-way),joystick (analog),joystick (8-way),joystick (analog)" : "controller_images/control_joystick_8analog.png",
   "joystick (2-way),joystick (analog)" : "controller_images/control_joystick_2analog.png",


   "joystick (8-way),trackball" : "controller_images/control_joystick_8trackball.png",
   "joystick (8-way),trackball,joystick (8-way),trackball" : "controller_images/control_joystick_8trackball.png",

   "joystick (8-way),positional" : "controller_images/control_joystick_8way.png",
   "joystick (8-way),positional,joystick (8-way),positional" : "controller_images/control_joystick_8way.png",
   "joystick (8-way),positional,joystick (8-way),positional,joystick (8-way),positional" : "controller_images/control_joystick_8way.png",
   "joystick (8-way),positional,joystick (8-way),positional,joystick (8-way)positional,joystick (8-way)positional" : "controller_images/control_joystick_8way.png",
   "joystick (5 (half8)-way),joystick (5 (half8)-way)" : "controller_images/control_joystick_8way.png",
   "joystick (5 (half8)-way)" : "controller_images/control_joystick_8way.png",

   "joystick (4-way)" : "controller_images/control_joystick_8way.png",
   "joystick (4-way),joystick (4-way)" : "controller_images/control_joystick_8way.png",
   "joystick (4-way),joystick (4-way),joystick (4-way),joystick (4-way)" : "controller_images/control_joystick_4way.png",
   "joystick (3 (half4)-way),joystick (3 (half4)-way)" : "controller_images/control_joystick_4way.png",
   "joystick (3 (half4)-way)" : "controller_images/control_joystick_4way.png",

   "joystick (2-way)" : "controller_images/control_joystick_8way.png",
   "joystick (vertical2-way)" : "controller_images/control_joystick_8way.png",
   "joystick (2-way),joystick (2-way)" : "controller_images/control_joystick_8way.png",
   "joystick (2-way),joystick (2-way),joystick (2-way),joystick (2-way)" : "controller_images/control_joystick_2way.png",

   "paddle,pedal" : "controller_images/control_paddle_pedal.png",
   "paddle,pedal,paddle,pedal" : "controller_images/control_paddle_pedal.png",

   "dial,pedal" : "controller_images/control_paddle_pedal.png",
   "dial,pedal,dial,pedal" : "controller_images/control_paddle_pedal.png",
   "dial,pedal,dial,pedal,dial,pedal" : "controller_images/control_paddle_pedal.png",
   "dial,pedal,dial,pedal,dial,pedal,dial,pedal" : "controller_images/control_paddle_pedal.png",

   "dial,paddle,pedal" : "controller_images/control_paddle_pedal.png",

   "joystick (analog)" : "controller_images/control_joystick_analog.png",
   "joystick (analog),joystick (analog)" : "controller_images/control_joystick_analog.png",

   "trackball" : "controller_images/control_trackball.png",
   "trackball,trackball" : "controller_images/control_trackball.png",
   "trackball,trackball,trackball" : "controller_images/control_trackball.png",

   "paddle" : "controller_images/control_paddle.png",
   "paddle,paddle" : "controller_images/control_paddle.png",

   "dial" : "controller_images/control_paddle.png",
   "dial,dial" : "controller_images/control_paddle.png",

   "only_buttons" : "controller_images/control_buttons.png",
   "only_buttons,only_buttons" : "controller_images/control_buttons.png",
   "only_buttons,only_buttons,only_buttons,only_buttons" : "controller_images/control_buttons.png",

   "double joystick" : "controller_images/control_double_joystick.png",
   "double joystick,double joystick" : "controller_images/control_double_joystick.png",

   "lightgun" : "controller_images/control_lightgun.png",
   "lightgun,lightgun" : "controller_images/control_lightgun.png",
}

function controller_pic(offset){
   local s = fe.game_info( Info.Control, offset )
   try {
      return (controllertable[s])
   }
   catch ( err ) {
      return ("white.png")
   }
   
}


function manufacturer_pic(offset){
   local s = fe.game_info( Info.Manufacturer, offset )
	local t = fe.game_info( Info.Title, offset )	
	
   local s2 = split( s, "*_/: .()-,<>?&+" )
	local sout =""
	if ( s2.len() > 1 ) {
		for (local i=0;i<s2.len();i++){
		if (s2[i] != "license")sout = sout + s2[i]
		}
		sout = sout.tolower()
	}
	else sout = strip(s).tolower()
	return "manufacturer_images/" + sout + ".png"
}

function maincategory(offset){
   local s = fe.game_info( Info.Category, offset )
	local s1 = split(s,"/")
   if (s1.len()>1) s = s1[0]

   local sout = strip(s).toupper()
   return sout
}

function category_pic(offset){
   local s = fe.game_info( Info.Category, offset )
//	local s1 = split(s,"/")
//   if (s1.len()>1) s = s1[0]

   local s2 = split( s, "*_/: .()-,<>?&+" )
	local sout =""
	if ( s2.len() > 1 ) {
		for (local i=0;i<s2.len();i++){
		 if (s2[i] != "Mature")  sout = sout + s2[i]
		}
		sout = sout.tolower()
	}
	else sout = strip(s).tolower()
	return "category_images/"+sout+".png"
}

function manufacturer_list(){
   local zout = ""
   local indexer = 0
   local s = ""
   local t = ""
   for (local i = 0; i<fe.list.size; i++){
      zout = manufacturer_pic(i)
      s = fe.game_info( Info.Manufacturer, i )
	   t = fe.game_info( Info.Title, i )	

      if (!(file_exist(fe.script_dir + zout))){
         indexer ++
         print(  indexer + " *** " + s + " *** " + t + "\n")
      }
   }
}

function category_list(){
   local zout = ""
   local indexer = 0
   local s = ""
   local t = ""
   for (local i = 0; i<fe.list.size; i++){
      zout = category_pic(i)
      s = fe.game_info( Info.Category, i )
	   t = fe.game_info( Info.Title, i )	

      if (!(file_exist(fe.script_dir + zout ))){
         indexer ++
         print(  indexer + " *** " + s + " *** " + t + " " + zout + "\n")
      }
   }
}

//listbrand()
//listcategory ()
